//**********************************************************************************************************
#include "PrecompiledHeader.h"

#include "Common.h"
//**********************************************************************************************************
using namespace JokersPlayer;


//**********************************************************************************************************

void MP3Infos :: Init()
{
	m_title.clear();
	m_track.clear();
	m_album.clear();
	m_year.clear();
	m_artist.clear();
	m_gender.clear();
}

//**********************************************************************************************************

bool JokersPlayer :: IsMedia( const wxString & p_path)
{
	return IsAudio( p_path) || IsVideo( p_path);
}

//**********************************************************************************************************

bool JokersPlayer :: IsAudio( const wxString & p_path)
{
	wxFileName l_fileName( p_path);
	wxString l_extension = l_fileName.GetExt();
	l_extension.MakeLower();
	if (l_extension == wxT( "mp3") || l_extension == wxT( "wma") || l_extension == wxT( "wav") ||
		l_extension == wxT( "ogg") || l_extension == wxT( "ac3"))
	{
		return true;
	}
	return false;
}

//**********************************************************************************************************

bool JokersPlayer :: IsVideo( const wxString & p_path)
{
	wxFileName l_fileName( p_path);
	size_t l_index = p_path.find_last_of( '.');
	wxString l_extension = p_path.SubString( l_index + 1, p_path.size());
	l_extension.MakeLower();
	if (l_extension == wxT( "wmv") || l_extension == wxT( "avi") || l_extension == wxT( "mpg") ||
		l_extension == wxT( "mpeg") || l_extension == wxT( "mp4") || l_extension == wxT( "divx") ||
		l_extension == wxT( "mkv"))
	{
		return true;
	}
	return false;
}

//**********************************************************************************************************

wxString JokersPlayer :: GetStringFromStringTable( unsigned int uStringID)
{
#ifdef WIN32
	wchar_t   * l_resource, * l_current;
	UINT      l_offset = uStringID / 16 + 1;
	int       l_index  = uStringID % 16;
	HINSTANCE l_hModule = NULL;
	HRSRC     l_hResource = NULL;

	l_hResource = FindResourceEx( NULL, RT_STRING, MAKEINTRESOURCE( l_offset),
								  MAKELANGID( LANG_NEUTRAL, SUBLANG_DEFAULT));

	if (l_hResource != NULL)
	{
		l_resource = (wchar_t *)LoadResource( l_hModule, l_hResource);

		if (l_resource != NULL)
		{
			l_current = l_resource;
			wchar_t * l_tmp = NULL;
			wxString l_result;
			for (int i = 0 ; i < 16 ; i++)
			{
				if ( * l_current)
				{
					int l_size = * l_current;  // String size in characters.
					l_current++;
					if (i == l_index)
					{
						// The string has been found in the string table.
						l_tmp = new wchar_t[l_size];
						wcsncpy( l_tmp, l_current, l_size);
						l_result = wxString( l_tmp, wxConvLibc, l_size);
						delete [] l_tmp;
						return l_result;
					}
					l_current += l_size;
				}
				else
				{
					l_current++;
				}
			}
		}
	}
#endif
	return wxEmptyString;
}

//**********************************************************************************************************

void JokersPlayer :: MBToWC( const wxString & p_str, wxWCharBuffer & p_buffer)
{
	p_buffer = p_str.wc_str( wxConvLocal);
}

//**********************************************************************************************************
