//**********************************************************************************************************
#ifndef ___JPException___
#define ___JPException___
//**********************************************************************************************************
#include <exception>
#include <string>
//**********************************************************************************************************
class JPException : public std::exception
{
public:
	unsigned int m_line;
	std::string m_description;
	const char * m_filename;
	const char * m_functionName;
	const char * m_typeDesc;

public:
	JPException(	const std::string & p_description, const char * p_file,
					const char * p_function, unsigned int p_line)
		:	m_line			(p_line),
			m_description	(p_description),
			m_filename		(p_file),
			m_functionName	(p_function)
	{}
	virtual ~JPException() throw() {}

public:
	inline virtual const char * what() const throw() { return m_description.c_str(); }
	inline const char * GetFilename()const { return m_filename; }
	inline const char * GetFunction()const { return m_functionName; }
	inline unsigned int GetLine()const { return m_line; }
	inline const std::string & GetDescription()const { return m_description; }
};
//**********************************************************************************************************
#define JP_EXCEPTION( p_text) throw JPException( p_text, __FILE__, __FUNCTION__, __LINE__)
//**********************************************************************************************************
#endif
//**********************************************************************************************************
