//******************************************************************************
#include "PrecompiledHeader.h"

#include "Log.h"
//******************************************************************************
using namespace JokersPlayer;
//******************************************************************************
wxString Log :: s_logFilePath;
//******************************************************************************

Log :: Log( wxString p_logFilePath)
{
#ifdef WIN32
	if (AllocConsole() == TRUE)
	{
		FILE * l_dump;
		freopen_s( & l_dump, "conout$", "w", stdout); 
		freopen_s( & l_dump, "conout$", "w", stderr);
	}
#endif
	s_logFilePath = p_logFilePath;
	FILE * l_logFile;
	l_logFile = fopen(s_logFilePath.char_str(), "w");

	if (l_logFile == NULL) 
	{
		return;
	}

	fclose( l_logFile);
}

//******************************************************************************

Log :: ~Log()
{
}

//******************************************************************************

void Log :: LogMessage( const char * cFormat_p , ...)
{
	FILE * l_logFile;
	l_logFile = fopen(s_logFilePath.char_str(), "a+");

	if (l_logFile == NULL) 
	{
		return;
	}

	char text_l[256];
	va_list ap_l;

	if (cFormat_p != NULL)		  
	{
		va_start( ap_l, cFormat_p);		  
        vsnprintf( text_l, 256, cFormat_p, ap_l);  
		va_end( ap_l);			 

		std::cout << text_l << "\n";
		fprintf( l_logFile, "%s\n", text_l);
	}

	fclose( l_logFile);
}

//******************************************************************************

void Log :: LogMessage( const wxString & p_msg)
{
	FILE * l_logFile;
	l_logFile = fopen( s_logFilePath.char_str(), "a+");

	if (l_logFile == NULL) 
	{
		return;
	}
	std::cout << p_msg.c_str() << "\n";
	fprintf( l_logFile, "%s\n", p_msg.char_str());

	fclose( l_logFile);
}

//******************************************************************************
