//**********************************************************************************************************
#ifndef JPFormEncodeH
#define JPFormEncodeH
//**********************************************************************************************************
#include <wx/frame.h>
#include "../Common.h"
//**********************************************************************************************************
namespace JokersPlayer
{
	class FormEncode : public wxFrame
	{
	private:
		wxTextCtrl * m_editFileIn;
#ifdef WIN32
		ImageButton * m_btnOpenFileIn;
		ImageButton * m_btnValidate;
		ImageButton * m_btnCancel;
		ImageButton * m_optionsBtn;
#else
		wxButton * m_btnOpenFileIn;
		wxButton * m_btnValidate;
		wxButton * m_btnCancel;
		wxButton * m_optionsBtn;
#endif
		wxStaticText * m_ststatus;
		ImageButton * m_btnCancel3;

		SimpleDesign * m_simpleDesign;
		wxString m_inFilePath;
		wxString m_outFilePath;
		EncodingOptions * m_encodingOptions;

	public:
		wxGauge * m_status;
		wxPanel * m_panelStepOne;
		wxPanel * m_panelStepThree;

	public:
		FormEncode( wxWindow * p_parent);
		void SetSimpleDesign( SimpleDesign * p_sd);
		void SetEncodingOptions( const EncodingOptions & p_options);

	private:
		void _onBtnOpenFileInClick	( wxCommandEvent & p_event);
		void _onEFileInKeyUp		( wxCommandEvent & p_event);
		void _onBtnCancelClick		( wxCommandEvent & p_event);
		void _onBtnValidateClick	( wxCommandEvent & p_event);
		void _onBtnCancel3Click		( wxCommandEvent & p_event);
		void _onOptionsBtnClick		( wxCommandEvent & p_event);

		DECLARE_EVENT_TABLE()
	};
}
//**********************************************************************************************************
#endif
//**********************************************************************************************************
