//**********************************************************************************************************
#ifndef ___JPFormEncodingOptions___
#define ___JPFormEncodingOptions___
//**********************************************************************************************************
#include "../Common.h"

#include <wx/frame.h>
//**********************************************************************************************************
namespace JokersPlayer
{
	class FormEncodingOptions : public wxFrame
	{
	private:
		wxNotebook * m_tabSet;
		wxPanel * m_generalTab;
		wxPanel * m_advancedTab;
		wxSlider * m_encodingQuality;
		wxStaticText * m_label1;
		wxStaticText * m_label2;
		wxStaticText * m_label3;
		wxStaticText * m_label4;
		wxStaticText * m_label5;
		wxStaticText * m_label6;
		wxStaticText * m_targetSampleRate;
		wxStaticBox * m_CBRGB;
		wxStaticBox * m_VBRGB;
		wxComboBox * m_VBRMin;
		wxComboBox * m_VBRMax;
		wxComboBox * m_VBRQuality;
		wxComboBox * m_sampleRate;
		wxComboBox * m_CBRBitRate;
#ifdef WIN32
		ImageButton * m_btnValidate;
		ImageButton * m_btnCancel;
#else
		wxButton * m_btnValidate;
		wxButton * m_btnCancel;
#endif
		wxRadioBox * m_encodingType;
		wxRadioBox * m_modeSelection;
		wxCheckBox * m_SEVBRMBR;
		wxCheckBox * m_VEM;
		wxCheckBox * m_KAF;
		wxCheckBox * m_MF;
		wxCheckBox * m_EXVBRT;
		wxCheckBox * m_DSB;
		wxCheckBox * m_SISOC;

		EncodingOptions m_encodingOptions;
		SimpleDesign * m_simpleDesign;

	public:		// User declarations
		FormEncodingOptions( wxWindow * p_parent);
		void SetSimpleDesign( SimpleDesign * p_sd);

	private:
		void _onBtnCancelClick			( wxCommandEvent & p_event);
		void _onSEVBRMBRClick			( wxCommandEvent & p_event);
		void _onVEMClick				( wxCommandEvent & p_event);
		void _onKAFClick				( wxCommandEvent & p_event);
		void _onSISOCClick				( wxCommandEvent & p_event);
		void _onDSBClick				( wxCommandEvent & p_event);
		void _onEXVBRTClick				( wxCommandEvent & p_event);
		void _onMFClick					( wxCommandEvent & p_event);
		void _onModeSelectionClick		( wxCommandEvent & p_event);
		void _onEncodingTypeClick		( wxCommandEvent & p_event);
		void _onCBRBitRateChange		( wxCommandEvent & p_event);
		void _onVBRMinChange			( wxCommandEvent & p_event);
		void _onVBRMaxChange			( wxCommandEvent & p_event);
		void _onVBRQualityChange		( wxCommandEvent & p_event);
		void _onEncodingQualityChange	( wxScrollEvent & p_event);
		void _onSampleRateChange		( wxCommandEvent & p_event);
		void _onBtnValidateClick		( wxCommandEvent & p_event);

		DECLARE_EVENT_TABLE()
	};
}
//**********************************************************************************************************
#endif                                                                     
//**********************************************************************************************************
