//**********************************************************************************************************
#include "PrecompiledHeader.h"

#include "../Log.h"

#include "FormMain.h"
#include "TaskBarIcon.h"
#include "FormPlaylist.h"
#include "FormEncode.h"
#include "FormVideo.h"
#include "../special/ImageButton.h"
#include "../other/AudioPlayerThread.h"
#include "../other/CDPlayerThread.h"
#include "../other/JokersCtrl.h"
#include "FormEncodingOptions.h"
#include "../main/JokersPlayer.h"
//**********************************************************************************************************
using namespace JokersPlayer;
const char * Joker_xpm[2090] = {
"64 64 2025 2",
"  	c #01CF02",
". 	c #01BA01",
"+ 	c #009902",
"@ 	c #018B01",
"# 	c #007A01",
"$ 	c #003602",
"% 	c #000B01",
"& 	c #003101",
"* 	c #006400",
"= 	c #009A01",
"- 	c #01BE01",
"; 	c #00AB01",
"> 	c #00A702",
", 	c #049A04",
"' 	c #0BF51F",
") 	c #0BFF24",
"! 	c #0BF021",
"~ 	c #0CC01F",
"{ 	c #0BBE1F",
"] 	c #0DB21F",
"^ 	c #0BA31B",
"/ 	c #0CB91C",
"( 	c #0CCD1F",
"_ 	c #0CB91E",
": 	c #0C9F1B",
"< 	c #0BAE1B",
"[ 	c #0BB81E",
"} 	c #066C12",
"| 	c #0AD11F",
"1 	c #0CFD22",
"2 	c #0DFB22",
"3 	c #0CE51F",
"4 	c #0CC01E",
"5 	c #0CCC1F",
"6 	c #0CED20",
"7 	c #0CD11E",
"8 	c #0BD51F",
"9 	c #0BD51E",
"0 	c #0CC31E",
"a 	c #0CB21F",
"b 	c #0CBF1E",
"c 	c #0CF820",
"d 	c #0BFF25",
"e 	c #0BFF22",
"f 	c #0CFE21",
"g 	c #0CFF25",
"h 	c #0BFE23",
"i 	c #04CE04",
"j 	c #008701",
"k 	c #008B01",
"l 	c #00A401",
"m 	c #00A701",
"n 	c #00AE01",
"o 	c #009100",
"p 	c #00AD01",
"q 	c #019E01",
"r 	c #009801",
"s 	c #01A302",
"t 	c #00B401",
"u 	c #00D203",
"v 	c #01D200",
"w 	c #01C401",
"x 	c #009C01",
"y 	c #00A101",
"z 	c #01B601",
"A 	c #027801",
"B 	c #003300",
"C 	c #015501",
"D 	c #017500",
"E 	c #007501",
"F 	c #019701",
"G 	c #00BE01",
"H 	c #00BD01",
"I 	c #01A600",
"J 	c #00E315",
"K 	c #01F817",
"L 	c #00EE15",
"M 	c #00C915",
"N 	c #00C114",
"O 	c #00BD13",
"P 	c #00BB13",
"Q 	c #01BB13",
"R 	c #00B512",
"S 	c #01A012",
"T 	c #00AA11",
"U 	c #01C013",
"V 	c #019B14",
"W 	c #015A10",
"X 	c #01AA13",
"Y 	c #01E717",
"Z 	c #01FA15",
"` 	c #00FE17",
" .	c #01D415",
"..	c #01B513",
"+.	c #01B412",
"@.	c #00D313",
"#.	c #01E015",
"$.	c #00EA15",
"%.	c #00DF15",
"&.	c #01A113",
"*.	c #019711",
"=.	c #00AC12",
"-.	c #01F016",
";.	c #01FF17",
">.	c #01FE19",
",.	c #01FF19",
"'.	c #00FF19",
").	c #01FF18",
"!.	c #00FD19",
"~.	c #01C700",
"{.	c #008B00",
"].	c #008900",
"^.	c #009701",
"/.	c #00A001",
"(.	c #009901",
"_.	c #00A000",
":.	c #00AB00",
"<.	c #01B700",
"[.	c #01B202",
"}.	c #00AA01",
"|.	c #00B001",
"1.	c #00B802",
"2.	c #019801",
"3.	c #009101",
"4.	c #00A501",
"5.	c #01B901",
"6.	c #01B300",
"7.	c #016201",
"8.	c #015000",
"9.	c #006201",
"0.	c #014B01",
"a.	c #015500",
"b.	c #018800",
"c.	c #01AA01",
"d.	c #02B500",
"e.	c #01E214",
"f.	c #01EA16",
"g.	c #00F316",
"h.	c #00CF14",
"i.	c #00A812",
"j.	c #019D11",
"k.	c #018F11",
"l.	c #008F12",
"m.	c #009310",
"n.	c #009513",
"o.	c #00E316",
"p.	c #008313",
"q.	c #013E0B",
"r.	c #018012",
"s.	c #01B814",
"t.	c #00C513",
"u.	c #01E213",
"v.	c #00DE15",
"w.	c #01E715",
"x.	c #01DF16",
"y.	c #00CA14",
"z.	c #00C713",
"A.	c #00F015",
"B.	c #01F814",
"C.	c #00620E",
"D.	c #017F0E",
"E.	c #00C314",
"F.	c #00F417",
"G.	c #00FF18",
"H.	c #01FF1A",
"I.	c #01FF1C",
"J.	c #00FB18",
"K.	c #01A700",
"L.	c #007E00",
"M.	c #008800",
"N.	c #018C01",
"O.	c #017E00",
"P.	c #01A601",
"Q.	c #019C01",
"R.	c #00BB00",
"S.	c #00C600",
"T.	c #00AC01",
"U.	c #009D00",
"V.	c #018102",
"W.	c #008C01",
"X.	c #007200",
"Y.	c #018200",
"Z.	c #018900",
"`.	c #005300",
" +	c #003400",
".+	c #012A01",
"++	c #013E01",
"@+	c #014C00",
"#+	c #016401",
"$+	c #00F616",
"%+	c #01ED14",
"&+	c #01AD12",
"*+	c #008710",
"=+	c #007C0E",
"-+	c #00740F",
";+	c #008110",
">+	c #029A11",
",+	c #00E615",
"'+	c #00A313",
")+	c #004F0D",
"!+	c #003B0C",
"~+	c #016B11",
"{+	c #01A412",
"]+	c #00A511",
"^+	c #01B613",
"/+	c #00EC15",
"(+	c #01FC15",
"_+	c #01E516",
":+	c #00D214",
"<+	c #01CC12",
"[+	c #01E413",
"}+	c #01CD15",
"|+	c #015F0F",
"1+	c #016910",
"2+	c #00C115",
"3+	c #01FD18",
"4+	c #00FF1A",
"5+	c #00FA16",
"6+	c #009E01",
"7+	c #017801",
"8+	c #008801",
"9+	c #008200",
"0+	c #00A500",
"a+	c #009400",
"b+	c #01AB02",
"c+	c #00C201",
"d+	c #00B400",
"e+	c #009F01",
"f+	c #01AA00",
"g+	c #009201",
"h+	c #009700",
"i+	c #016E00",
"j+	c #015B01",
"k+	c #016300",
"l+	c #016200",
"m+	c #005900",
"n+	c #001A00",
"o+	c #012001",
"p+	c #003B00",
"q+	c #003C01",
"r+	c #013C01",
"s+	c #007101",
"t+	c #00DD11",
"u+	c #01DC11",
"v+	c #00A711",
"w+	c #017A10",
"x+	c #00A110",
"y+	c #00B312",
"z+	c #00BB10",
"A+	c #00A413",
"B+	c #009D12",
"C+	c #00BC14",
"D+	c #01A013",
"E+	c #015F10",
"F+	c #00390A",
"G+	c #013309",
"H+	c #015A0E",
"I+	c #009612",
"J+	c #01A213",
"K+	c #01BA12",
"L+	c #00FC15",
"M+	c #00F816",
"N+	c #00E416",
"O+	c #01EA15",
"P+	c #00CD14",
"Q+	c #00D014",
"R+	c #01A615",
"S+	c #01430C",
"T+	c #01540D",
"U+	c #019B12",
"V+	c #01C814",
"W+	c #00EC16",
"X+	c #01FE18",
"Y+	c #01FB16",
"Z+	c #01AD01",
"`+	c #007A00",
" @	c #007C00",
".@	c #018F01",
"+@	c #007F00",
"@@	c #018B00",
"#@	c #00A201",
"$@	c #00C500",
"%@	c #00AF01",
"&@	c #009200",
"*@	c #008600",
"=@	c #00AD00",
"-@	c #017A00",
";@	c #005201",
">@	c #003401",
",@	c #014A01",
"'@	c #015701",
")@	c #004201",
"!@	c #012A00",
"~@	c #003000",
"{@	c #002A01",
"]@	c #012301",
"^@	c #005C00",
"/@	c #00A90F",
"(@	c #00900D",
"_@	c #006F10",
":@	c #007C0F",
"<@	c #01C012",
"[@	c #01B912",
"}@	c #01B911",
"|@	c #01C311",
"1@	c #00AF11",
"2@	c #018E12",
"3@	c #016210",
"4@	c #003F0B",
"5@	c #013409",
"6@	c #013509",
"7@	c #00400A",
"8@	c #017712",
"9@	c #00BE12",
"0@	c #01E814",
"a@	c #00ED14",
"b@	c #01DD15",
"c@	c #00E014",
"d@	c #01B212",
"e@	c #00BA13",
"f@	c #017D13",
"g@	c #00340B",
"h@	c #013D0B",
"i@	c #007711",
"j@	c #00E016",
"k@	c #01FD17",
"l@	c #018501",
"m@	c #008F01",
"n@	c #008A01",
"o@	c #008602",
"p@	c #008400",
"q@	c #009401",
"r@	c #01BF00",
"s@	c #018101",
"t@	c #00A600",
"u@	c #005B00",
"v@	c #002200",
"w@	c #001800",
"x@	c #012800",
"y@	c #022F01",
"z@	c #001E02",
"A@	c #012000",
"B@	c #001F00",
"C@	c #001601",
"D@	c #011F00",
"E@	c #014300",
"F@	c #00730E",
"G@	c #00650D",
"H@	c #01800E",
"I@	c #01BB10",
"J@	c #01A310",
"K@	c #008E12",
"L@	c #00890F",
"M@	c #025E10",
"N@	c #01480D",
"O@	c #00390B",
"P@	c #003309",
"Q@	c #01360A",
"R@	c #002F0A",
"S@	c #00BC12",
"T@	c #00CE15",
"U@	c #01CE13",
"V@	c #01CB15",
"W@	c #00C011",
"X@	c #00B413",
"Y@	c #01B813",
"Z@	c #009F14",
"`@	c #015610",
" #	c #01350A",
".#	c #014E0F",
"+#	c #019713",
"@#	c #01FE17",
"##	c #00D600",
"$#	c #019000",
"%#	c #007801",
"&#	c #017C00",
"*#	c #017901",
"=#	c #00B500",
"-#	c #01C000",
";#	c #019501",
">#	c #018500",
",#	c #008000",
"'#	c #018301",
")#	c #018E01",
"!#	c #018100",
"~#	c #005E01",
"{#	c #003B01",
"]#	c #003200",
"^#	c #001B00",
"/#	c #000301",
"(#	c #000800",
"_#	c #000E00",
":#	c #011200",
"<#	c #001401",
"[#	c #012300",
"}#	c #00630C",
"|#	c #00600E",
"1#	c #005E0D",
"2#	c #007E0E",
"3#	c #00B711",
"4#	c #009E0F",
"5#	c #009510",
"6#	c #026A0F",
"7#	c #025810",
"8#	c #01400C",
"9#	c #003D0B",
"0#	c #003B0B",
"a#	c #013609",
"b#	c #013C0A",
"c#	c #008111",
"d#	c #01C513",
"e#	c #00D915",
"f#	c #00DF14",
"g#	c #00D113",
"h#	c #00D013",
"i#	c #00D413",
"j#	c #017213",
"k#	c #013209",
"l#	c #00340A",
"m#	c #003809",
"n#	c #02360A",
"o#	c #01580F",
"p#	c #01B614",
"q#	c #01F717",
"r#	c #00FE14",
"s#	c #01F918",
"t#	c #00FF17",
"u#	c #00FF16",
"v#	c #00F500",
"w#	c #01CB01",
"x#	c #008101",
"y#	c #017400",
"z#	c #007100",
"A#	c #007301",
"B#	c #017101",
"C#	c #008401",
"D#	c #00B801",
"E#	c #00B301",
"F#	c #00A100",
"G#	c #009500",
"H#	c #016D00",
"I#	c #006601",
"J#	c #006101",
"K#	c #006100",
"L#	c #015D01",
"M#	c #013601",
"N#	c #000701",
"O#	c #010001",
"P#	c #000100",
"Q#	c #010200",
"R#	c #001001",
"S#	c #01530B",
"T#	c #005A0D",
"U#	c #00640E",
"V#	c #018B0F",
"W#	c #00BD10",
"X#	c #01A00F",
"Y#	c #00A011",
"Z#	c #01410B",
"`#	c #003009",
" $	c #003A0B",
".$	c #003509",
"+$	c #003E0B",
"@$	c #013B0B",
"#$	c #006210",
"$$	c #01AB12",
"%$	c #00EE16",
"&$	c #00F314",
"*$	c #01EE15",
"=$	c #00A616",
"-$	c #014E0D",
";$	c #003E0A",
">$	c #013C0B",
",$	c #003A0A",
"'$	c #023A0B",
")$	c #01520D",
"!$	c #00A214",
"~$	c #00CE14",
"{$	c #01CA15",
"]$	c #01E913",
"^$	c #01FC14",
"/$	c #00FE00",
"($	c #00EC00",
"_$	c #019A00",
":$	c #017800",
"<$	c #006C00",
"[$	c #016E01",
"}$	c #016B01",
"|$	c #007701",
"1$	c #00A300",
"2$	c #007901",
"3$	c #005A00",
"4$	c #004F00",
"5$	c #016101",
"6$	c #004800",
"7$	c #010E01",
"8$	c #010101",
"9$	c #000201",
"0$	c #000300",
"a$	c #010102",
"b$	c #000001",
"c$	c #001101",
"d$	c #015B0B",
"e$	c #016F0C",
"f$	c #00710E",
"g$	c #009D0F",
"h$	c #01B413",
"i$	c #009C12",
"j$	c #00800E",
"k$	c #00520E",
"l$	c #012F08",
"m$	c #013709",
"n$	c #01410C",
"o$	c #013809",
"p$	c #013E0A",
"q$	c #012F09",
"r$	c #013A0A",
"s$	c #00380A",
"t$	c #01540E",
"u$	c #018412",
"v$	c #00B315",
"w$	c #01AA14",
"x$	c #007C11",
"y$	c #014B0D",
"z$	c #003C0A",
"A$	c #013A0B",
"B$	c #013A0C",
"C$	c #01390A",
"D$	c #00420B",
"E$	c #00580F",
"F$	c #026411",
"G$	c #008811",
"H$	c #01E811",
"I$	c #00E401",
"J$	c #00E501",
"K$	c #00D701",
"L$	c #019101",
"M$	c #017B01",
"N$	c #026F01",
"O$	c #006801",
"P$	c #007900",
"Q$	c #018A01",
"R$	c #009A00",
"S$	c #007E01",
"T$	c #016501",
"U$	c #015A01",
"V$	c #005801",
"W$	c #016C01",
"X$	c #005700",
"Y$	c #001000",
"Z$	c #010300",
"`$	c #011401",
" %	c #002901",
".%	c #001F01",
"+%	c #000500",
"@%	c #010201",
"#%	c #011E01",
"$%	c #00710D",
"%%	c #006B0C",
"&%	c #01660D",
"*%	c #00A50F",
"=%	c #00B211",
"-%	c #00A713",
";%	c #01710F",
">%	c #005F11",
",%	c #003F0A",
"'%	c #003409",
")%	c #01370A",
"!%	c #01390B",
"~%	c #003B0A",
"{%	c #01380B",
"]%	c #00440D",
"^%	c #01440B",
"/%	c #00450C",
"(%	c #013D0C",
"_%	c #01440C",
":%	c #013E0C",
"<%	c #003F0C",
"[%	c #002908",
"}%	c #003209",
"|%	c #006E11",
"1%	c #009912",
"2%	c #02CB13",
"3%	c #00C501",
"4%	c #00BC00",
"5%	c #00CE00",
"6%	c #00CB01",
"7%	c #01AB01",
"8%	c #018701",
"9%	c #018400",
"0%	c #008901",
"a%	c #007B01",
"b%	c #00B200",
"c%	c #008202",
"d%	c #017001",
"e%	c #006F00",
"f%	c #014002",
"g%	c #001700",
"h%	c #003501",
"i%	c #014200",
"j%	c #013401",
"k%	c #002000",
"l%	c #010800",
"m%	c #012901",
"n%	c #00730C",
"o%	c #016A0E",
"p%	c #006E0E",
"q%	c #01A50F",
"r%	c #01BD13",
"s%	c #00C613",
"t%	c #027812",
"u%	c #015F11",
"v%	c #015C10",
"w%	c #015E11",
"x%	c #004B0D",
"y%	c #00410A",
"z%	c #00420C",
"A%	c #00460D",
"B%	c #013C0C",
"C%	c #003C0B",
"D%	c #01420D",
"E%	c #01430B",
"F%	c #01330A",
"G%	c #002B08",
"H%	c #01420B",
"I%	c #014D0E",
"J%	c #01500E",
"K%	c #005D0F",
"L%	c #007A0E",
"M%	c #01A612",
"N%	c #00A700",
"O%	c #007F01",
"P%	c #00A800",
"Q%	c #00C700",
"R%	c #019301",
"S%	c #009600",
"T%	c #018D00",
"U%	c #019601",
"V%	c #008F00",
"W%	c #01A201",
"X%	c #00D301",
"Y%	c #01D900",
"Z%	c #01AB00",
"`%	c #017F01",
" &	c #016600",
".&	c #002301",
"+&	c #001901",
"@&	c #000601",
"#&	c #001301",
"$&	c #00510D",
"%&	c #01660E",
"&&	c #008F0F",
"*&	c #00AA10",
"=&	c #01BE13",
"-&	c #00A411",
";&	c #005B0E",
">&	c #01450C",
",&	c #01570F",
"'&	c #014F0F",
")&	c #00460B",
"!&	c #013F0C",
"~&	c #013B09",
"{&	c #00410B",
"]&	c #01470D",
"^&	c #00420A",
"/&	c #01470C",
"(&	c #024A0D",
"_&	c #01510E",
":&	c #01500F",
"<&	c #004E0E",
"[&	c #025210",
"}&	c #01670E",
"|&	c #008C10",
"1&	c #01B512",
"2&	c #00C401",
"3&	c #009F00",
"4&	c #01AE00",
"5&	c #01AE01",
"6&	c #01CA01",
"7&	c #01D101",
"8&	c #00A801",
"9&	c #009B00",
"0&	c #008A00",
"a&	c #016901",
"b&	c #007700",
"c&	c #017401",
"d&	c #002800",
"e&	c #010400",
"f&	c #011501",
"g&	c #000D01",
"h&	c #001201",
"i&	c #01680F",
"j&	c #00A412",
"k&	c #009111",
"l&	c #016411",
"m&	c #014D0D",
"n&	c #00470D",
"o&	c #01460D",
"p&	c #00360A",
"q&	c #003007",
"r&	c #01360B",
"s&	c #00420D",
"t&	c #00400C",
"u&	c #003C09",
"v&	c #00410D",
"w&	c #01490D",
"x&	c #013408",
"y&	c #002C09",
"z&	c #00480D",
"A&	c #008C0F",
"B&	c #00C810",
"C&	c #009300",
"D&	c #019700",
"E&	c #00B600",
"F&	c #00AC02",
"G&	c #00C000",
"H&	c #00BD02",
"I&	c #01A000",
"J&	c #00A601",
"K&	c #005600",
"L&	c #016900",
"M&	c #005001",
"N&	c #001801",
"O&	c #010601",
"P&	c #010F00",
"Q&	c #011D01",
"R&	c #01660B",
"S&	c #00720D",
"T&	c #00AC10",
"U&	c #018F12",
"V&	c #00470C",
"W&	c #003109",
"X&	c #01490B",
"Y&	c #01400B",
"Z&	c #012B08",
"`&	c #01460C",
" *	c #00440B",
".*	c #00400B",
"+*	c #013F0B",
"@*	c #00410C",
"#*	c #01450B",
"$*	c #01370B",
"%*	c #01480C",
"&*	c #016011",
"**	c #01450D",
"=*	c #025C0E",
"-*	c #007F0F",
";*	c #018801",
">*	c #018600",
",*	c #01A500",
"'*	c #00C100",
")*	c #019E00",
"!*	c #01A001",
"~*	c #018401",
"{*	c #009E00",
"]*	c #01B501",
"^*	c #009301",
"/*	c #007300",
"(*	c #016100",
"_*	c #006A01",
":*	c #018201",
"<*	c #004A01",
"[*	c #012F01",
"}*	c #010D01",
"|*	c #002500",
"1*	c #00790C",
"2*	c #01820F",
"3*	c #01900F",
"4*	c #02600F",
"5*	c #004A0F",
"6*	c #014A0F",
"7*	c #022808",
"8*	c #01420C",
"9*	c #012407",
"0*	c #01520E",
"a*	c #014E0E",
"b*	c #014B0E",
"c*	c #003C0C",
"d*	c #01560E",
"e*	c #01810F",
"f*	c #01BB0F",
"g*	c #007800",
"h*	c #00B000",
"i*	c #00D000",
"j*	c #01B201",
"k*	c #019300",
"l*	c #008E01",
"m*	c #008E00",
"n*	c #009C00",
"o*	c #01B500",
"p*	c #008301",
"q*	c #005D01",
"r*	c #007000",
"s*	c #013801",
"t*	c #012402",
"u*	c #001701",
"v*	c #000200",
"w*	c #017C0E",
"x*	c #00810C",
"y*	c #017E0D",
"z*	c #014109",
"A*	c #024B0D",
"B*	c #00560D",
"C*	c #004B0E",
"D*	c #016112",
"E*	c #00450B",
"F*	c #013909",
"G*	c #003E0C",
"H*	c #00430C",
"I*	c #00510E",
"J*	c #01410A",
"K*	c #027713",
"L*	c #01B40F",
"M*	c #00D001",
"N*	c #01A101",
"O*	c #017D00",
"P*	c #017F00",
"Q*	c #019D00",
"R*	c #019500",
"S*	c #016500",
"T*	c #007B00",
"U*	c #017B00",
"V*	c #004701",
"W*	c #015401",
"X*	c #004C00",
"Y*	c #011701",
"Z*	c #01700C",
"`*	c #016D0D",
" =	c #01740D",
".=	c #014B0C",
"+=	c #015910",
"@=	c #015710",
"#=	c #015E12",
"$=	c #01530F",
"%=	c #014A0C",
"&=	c #015812",
"*=	c #01540F",
"==	c #014C0D",
"-=	c #02440D",
";=	c #01420A",
">=	c #02420C",
",=	c #014A0E",
"'=	c #005A10",
")=	c #024F0E",
"!=	c #016010",
"~=	c #008D0F",
"{=	c #00B300",
"]=	c #00AF00",
"^=	c #017900",
"/=	c #006E00",
"(=	c #007401",
"_=	c #007001",
":=	c #01A800",
"<=	c #019F00",
"[=	c #00A901",
"}=	c #006701",
"|=	c #017201",
"1=	c #004D00",
"2=	c #005501",
"3=	c #013802",
"4=	c #001A01",
"5=	c #000700",
"6=	c #001600",
"7=	c #006A0B",
"8=	c #006A0C",
"9=	c #00670D",
"0=	c #014C0B",
"a=	c #00430B",
"b=	c #00470B",
"c=	c #014F0E",
"d=	c #00560E",
"e=	c #014C0C",
"f=	c #01430D",
"g=	c #005A11",
"h=	c #026812",
"i=	c #01490C",
"j=	c #012D09",
"k=	c #013308",
"l=	c #014A0A",
"m=	c #018403",
"n=	c #019201",
"o=	c #019B01",
"p=	c #006700",
"q=	c #015302",
"r=	c #015801",
"s=	c #016800",
"t=	c #005500",
"u=	c #007400",
"v=	c #009F02",
"w=	c #018F00",
"x=	c #018000",
"y=	c #017A01",
"z=	c #017301",
"A=	c #015C01",
"B=	c #014F01",
"C=	c #001B01",
"D=	c #010402",
"E=	c #00710C",
"F=	c #01790D",
"G=	c #016D0E",
"H=	c #016810",
"I=	c #00480E",
"J=	c #00490E",
"K=	c #026512",
"L=	c #00440C",
"M=	c #00460E",
"N=	c #026212",
"O=	c #016612",
"P=	c #02530E",
"Q=	c #00370A",
"R=	c #015901",
"S=	c #014F02",
"T=	c #004700",
"U=	c #015201",
"V=	c #004B01",
"W=	c #008201",
"X=	c #01B900",
"Y=	c #008D01",
"Z=	c #017E01",
"`=	c #006A00",
" -	c #008500",
".-	c #006D00",
"+-	c #011B00",
"@-	c #000000",
"#-	c #002D01",
"$-	c #008A0D",
"%-	c #00740C",
"&-	c #015A0F",
"*-	c #00460C",
"=-	c #015310",
"--	c #00430D",
";-	c #015C11",
">-	c #00520F",
",-	c #016312",
"'-	c #01460B",
")-	c #00B410",
"!-	c #001C00",
"~-	c #003301",
"{-	c #015F01",
"]-	c #016001",
"^-	c #015101",
"/-	c #013F01",
"(-	c #004901",
"_-	c #018C00",
":-	c #006B02",
"<-	c #018300",
"[-	c #016601",
"}-	c #007C01",
"|-	c #008700",
"1-	c #002501",
"2-	c #010600",
"3-	c #004000",
"4-	c #00860E",
"5-	c #01680D",
"6-	c #014C0E",
"7-	c #024E0E",
"8-	c #025310",
"9-	c #015510",
"0-	c #00490C",
"a-	c #015810",
"b-	c #02510D",
"c-	c #004F0E",
"d-	c #004D0C",
"e-	c #016110",
"f-	c #01C011",
"g-	c #014501",
"h-	c #015F02",
"i-	c #013B01",
"j-	c #014101",
"k-	c #004A00",
"l-	c #014B00",
"m-	c #013901",
"n-	c #00A400",
"o-	c #008501",
"p-	c #017600",
"q-	c #008502",
"r-	c #003F01",
"s-	c #000A01",
"t-	c #013501",
"u-	c #00750D",
"v-	c #005B0D",
"w-	c #02630F",
"x-	c #015D10",
"y-	c #004A0D",
"z-	c #014A0B",
"A-	c #014A0D",
"B-	c #014D0F",
"C-	c #01490E",
"D-	c #004C0D",
"E-	c #01B20F",
"F-	c #006000",
"G-	c #006900",
"H-	c #002A00",
"I-	c #014301",
"J-	c #025201",
"K-	c #004500",
"L-	c #014E01",
"M-	c #021200",
"N-	c #002E01",
"O-	c #017A0D",
"P-	c #02610F",
"Q-	c #015B0F",
"R-	c #01530E",
"S-	c #015410",
"T-	c #024D0C",
"U-	c #00450D",
"V-	c #01510D",
"W-	c #01480E",
"X-	c #01B910",
"Y-	c #006F01",
"Z-	c #004C01",
"`-	c #015B00",
" ;	c #013600",
".;	c #013A00",
"+;	c #005701",
"@;	c #003700",
"#;	c #003C00",
"$;	c #027201",
"%;	c #006B00",
"&;	c #014401",
"*;	c #012B00",
"=;	c #006D0F",
"-;	c #01600F",
";;	c #024C0F",
">;	c #01440D",
",;	c #02500E",
"';	c #01590F",
");	c #024B0E",
"!;	c #013F0A",
"~;	c #004C0E",
"{;	c #014B0F",
"];	c #014C10",
"^;	c #00570F",
"/;	c #00C811",
"(;	c #013C00",
"_;	c #013E00",
":;	c #013100",
"<;	c #006200",
"[;	c #005E00",
"};	c #012E00",
"|;	c #002B01",
"1;	c #015700",
"2;	c #004401",
"3;	c #015100",
"4;	c #018902",
"5;	c #016F01",
"6;	c #00A301",
"7;	c #017D01",
"8;	c #004600",
"9;	c #003E03",
"0;	c #00570E",
"a;	c #004D0D",
"b;	c #00350A",
"c;	c #00480B",
"d;	c #02540E",
"e;	c #015010",
"f;	c #004B0B",
"g;	c #014F0D",
"h;	c #009E10",
"i;	c #005401",
"j;	c #002001",
"k;	c #016700",
"l;	c #015800",
"m;	c #013800",
"n;	c #012101",
"o;	c #005901",
"p;	c #005F01",
"q;	c #016D01",
"r;	c #016801",
"s;	c #01AF01",
"t;	c #016202",
"u;	c #005D00",
"v;	c #01640E",
"w;	c #013A09",
"x;	c #016912",
"y;	c #024E0F",
"z;	c #024C0C",
"A;	c #004D0E",
"B;	c #016211",
"C;	c #018810",
"D;	c #014701",
"E;	c #011B01",
"F;	c #012801",
"G;	c #003100",
"H;	c #013201",
"I;	c #012C00",
"J;	c #004101",
"K;	c #007201",
"L;	c #008001",
"M;	c #006300",
"N;	c #00B201",
"O;	c #019901",
"P;	c #018E00",
"Q;	c #01BC10",
"R;	c #014E0C",
"S;	c #016C13",
"T;	c #026D11",
"U;	c #005F10",
"V;	c #026012",
"W;	c #01560F",
"X;	c #00350B",
"Y;	c #024F0F",
"Z;	c #024D0E",
"`;	c #003408",
" >	c #02540F",
".>	c #024E0D",
"+>	c #024A0E",
"@>	c #02420D",
"#>	c #014D0C",
"$>	c #006B0F",
"%>	c #014001",
"&>	c #001500",
"*>	c #002101",
"=>	c #010701",
"->	c #012200",
";>	c #014801",
">>	c #005C01",
",>	c #016301",
"'>	c #00D300",
")>	c #00DA01",
"!>	c #00D402",
"~>	c #01CD01",
"{>	c #00E714",
"]>	c #006C0E",
"^>	c #01520F",
"/>	c #01550E",
"(>	c #00300A",
"_>	c #017B17",
":>	c #004E0D",
"<>	c #003108",
"[>	c #023C0A",
"}>	c #01550F",
"|>	c #005A0F",
"1>	c #003709",
"2>	c #02620F",
"3>	c #014C01",
"4>	c #011801",
"5>	c #010C00",
"6>	c #012B01",
"7>	c #002401",
"8>	c #001E01",
"9>	c #011D00",
"0>	c #003502",
"a>	c #002801",
"b>	c #006401",
"c>	c #008100",
"d>	c #01D901",
"e>	c #00EF01",
"f>	c #00FC00",
"g>	c #01FE00",
"h>	c #00EB01",
"i>	c #00B700",
"j>	c #00DE13",
"k>	c #017E11",
"l>	c #025411",
"m>	c #01510F",
"n>	c #006911",
"o>	c #017715",
"p>	c #006A13",
"q>	c #026412",
"r>	c #00510F",
"s>	c #015B10",
"t>	c #002A07",
"u>	c #012A08",
"v>	c #02480F",
"w>	c #025711",
"x>	c #01550D",
"y>	c #00500E",
"z>	c #026612",
"A>	c #01470B",
"B>	c #005804",
"C>	c #012701",
"D>	c #010B00",
"E>	c #013301",
"F>	c #014700",
"G>	c #003600",
"H>	c #012400",
"I>	c #013302",
"J>	c #01D600",
"K>	c #01DA00",
"L>	c #00DD00",
"M>	c #00BE00",
"N>	c #00CF00",
"O>	c #01EE14",
"P>	c #009E13",
"Q>	c #02500F",
"R>	c #016512",
"S>	c #02550F",
"T>	c #016111",
"U>	c #016B13",
"V>	c #016A12",
"W>	c #013108",
"X>	c #02490E",
"Y>	c #00500F",
"Z>	c #016913",
"`>	c #00500D",
" ,	c #010B01",
".,	c #003900",
"+,	c #014900",
"@,	c #015900",
"#,	c #016400",
"$,	c #004B00",
"%,	c #015601",
"&,	c #019900",
"*,	c #01A701",
"=,	c #01AC01",
"-,	c #01AC00",
";,	c #00D202",
">,	c #00FD16",
",,	c #00560F",
"',	c #025910",
"),	c #006713",
"!,	c #02590F",
"~,	c #004A0C",
"{,	c #027E17",
"],	c #004E0C",
"^,	c #024C0E",
"/,	c #00600C",
"(,	c #00B20E",
"_,	c #005100",
":,	c #011300",
"<,	c #003701",
"[,	c #014C02",
"},	c #014901",
"|,	c #014D01",
"1,	c #018901",
"2,	c #017000",
"3,	c #004E01",
"4,	c #006501",
"5,	c #008601",
"6,	c #009501",
"7,	c #00F818",
"8,	c #005F0F",
"9,	c #005510",
"0,	c #02520F",
"a,	c #00550F",
"b,	c #02530F",
"c,	c #005010",
"d,	c #017A15",
"e,	c #015C0F",
"f,	c #02500C",
"g,	c #027F18",
"h,	c #02941B",
"i,	c #016B12",
"j,	c #00AD0F",
"k,	c #012E01",
"l,	c #01BC01",
"m,	c #01C301",
"n,	c #009D01",
"o,	c #003800",
"p,	c #015402",
"q,	c #006002",
"r,	c #00AA00",
"s,	c #018502",
"t,	c #01C811",
"u,	c #02560E",
"v,	c #015611",
"w,	c #025510",
"x,	c #02470D",
"y,	c #015E10",
"z,	c #01410D",
"A,	c #01530D",
"B,	c #02550E",
"C,	c #015811",
"D,	c #015B11",
"E,	c #007D0F",
"F,	c #00930B",
"G,	c #006800",
"H,	c #015E00",
"I,	c #01D201",
"J,	c #01D801",
"K,	c #001D00",
"L,	c #00C701",
"M,	c #01D012",
"N,	c #01570E",
"O,	c #01580E",
"P,	c #01500D",
"Q,	c #02570F",
"R,	c #00700D",
"S,	c #017B0D",
"T,	c #004400",
"U,	c #015600",
"V,	c #003D01",
"W,	c #00AC00",
"X,	c #019802",
"Y,	c #01AE02",
"Z,	c #00BF00",
"`,	c #00E101",
" '	c #00E800",
".'	c #00D500",
"+'	c #01B000",
"@'	c #01E615",
"#'	c #01C215",
"$'	c #016812",
"%'	c #015A11",
"&'	c #025E11",
"*'	c #016712",
"='	c #01340A",
"-'	c #02510F",
";'	c #01640C",
">'	c #01760C",
",'	c #01690C",
"''	c #00E200",
")'	c #01DC00",
"!'	c #011700",
"~'	c #00BB01",
"{'	c #009302",
"]'	c #008C00",
"^'	c #00CE01",
"/'	c #01DB00",
"('	c #00C801",
"_'	c #01BA00",
":'	c #00E601",
"<'	c #01F214",
"['	c #00B115",
"}'	c #014C0F",
"|'	c #02490C",
"1'	c #025A11",
"2'	c #01800F",
"3'	c #01740E",
"4'	c #026C0D",
"5'	c #013701",
"6'	c #01D701",
"7'	c #01EB01",
"8'	c #005601",
"9'	c #00A902",
"0'	c #00C301",
"a'	c #00C802",
"b'	c #01D301",
"c'	c #00D400",
"d'	c #02BA02",
"e'	c #01C200",
"f'	c #01C300",
"g'	c #00DB01",
"h'	c #00F416",
"i'	c #019114",
"j'	c #00530E",
"k'	c #012E0A",
"l'	c #012F07",
"m'	c #012E09",
"n'	c #025B10",
"o'	c #023B0B",
"p'	c #025C10",
"q'	c #015911",
"r'	c #00520B",
"s'	c #00870E",
"t'	c #00960A",
"u'	c #011E00",
"v'	c #004200",
"w'	c #013A01",
"x'	c #006001",
"y'	c #014601",
"z'	c #00CD01",
"A'	c #00DA00",
"B'	c #01CB00",
"C'	c #01C601",
"D'	c #00CC01",
"E'	c #01C800",
"F'	c #01C501",
"G'	c #01A900",
"H'	c #00CA01",
"I'	c #00EB15",
"J'	c #017911",
"K'	c #026913",
"L'	c #026A13",
"M'	c #025911",
"N'	c #025710",
"O'	c #015711",
"P'	c #015D0F",
"Q'	c #025F11",
"R'	c #006910",
"S'	c #00AD0E",
"T'	c #00A90D",
"U'	c #012601",
"V'	c #004E00",
"W'	c #005000",
"X'	c #005200",
"Y'	c #003A00",
"Z'	c #000901",
"`'	c #000A02",
" )	c #015F00",
".)	c #006E01",
"+)	c #00DC01",
"@)	c #00D801",
"#)	c #01D802",
"$)	c #00B501",
"%)	c #00C001",
"&)	c #01AF00",
"*)	c #00C800",
"=)	c #00D314",
"-)	c #00480C",
";)	c #026C13",
">)	c #015C12",
",)	c #003B09",
"')	c #005E10",
"))	c #024D0D",
"!)	c #026111",
"~)	c #00900E",
"{)	c #01B20E",
"])	c #01790B",
"^)	c #013300",
"/)	c #010401",
"()	c #017300",
"_)	c #01E101",
":)	c #00D401",
"<)	c #01C201",
"[)	c #00D601",
"})	c #01CD00",
"|)	c #01BC00",
"1)	c #00B901",
"2)	c #01BB01",
"3)	c #01D601",
"4)	c #01FD16",
"5)	c #019212",
"6)	c #025F0F",
"7)	c #016611",
"8)	c #016511",
"9)	c #015D11",
"0)	c #025D11",
"a)	c #012A07",
"b)	c #016212",
"c)	c #017014",
"d)	c #006F0D",
"e)	c #008E0C",
"f)	c #01940C",
"g)	c #004501",
"h)	c #011C01",
"i)	c #001200",
"j)	c #010E00",
"k)	c #000E01",
"l)	c #002201",
"m)	c #01C701",
"n)	c #00E900",
"o)	c #00D100",
"p)	c #01C801",
"q)	c #00CC00",
"r)	c #00C400",
"s)	c #01AD00",
"t)	c #00D700",
"u)	c #00D517",
"v)	c #02570D",
"w)	c #026211",
"x)	c #016811",
"y)	c #006612",
"z)	c #023609",
"A)	c #016012",
"B)	c #025410",
"C)	c #012F0A",
"D)	c #026511",
"E)	c #026912",
"F)	c #02580E",
"G)	c #007E0D",
"H)	c #00760D",
"I)	c #01970D",
"J)	c #00BF0E",
"K)	c #011001",
"L)	c #000F01",
"M)	c #004F01",
"N)	c #004301",
"O)	c #01F101",
"P)	c #00CF01",
"Q)	c #00CB00",
"R)	c #00CD00",
"S)	c #01B800",
"T)	c #01B801",
"U)	c #01D500",
"V)	c #01EA01",
"W)	c #00F317",
"X)	c #017B0F",
"Y)	c #026011",
"Z)	c #004F0F",
"`)	c #035710",
" !	c #016412",
".!	c #025A10",
"+!	c #005E0F",
"@!	c #016813",
"#!	c #014F0C",
"$!	c #013708",
"%!	c #00780E",
"&!	c #01A712",
"*!	c #00830C",
"=!	c #00890D",
"-!	c #01BD0E",
";!	c #004601",
">!	c #035501",
",!	c #006301",
"'!	c #001D01",
")!	c #003901",
"!!	c #002600",
"~!	c #002C00",
"{!	c #00F100",
"]!	c #00D800",
"^!	c #00DB00",
"/!	c #00DE01",
"(!	c #01E500",
"_!	c #01F500",
":!	c #01FF1E",
"<!	c #01AD14",
"[!	c #015110",
"}!	c #026410",
"|!	c #00750F",
"1!	c #019F13",
"2!	c #002C07",
"3!	c #00330B",
"4!	c #006412",
"5!	c #005A0E",
"6!	c #009412",
"7!	c #01CD14",
"8!	c #01B611",
"9!	c #00BA0F",
"0!	c #00A50E",
"a!	c #00AB0E",
"b!	c #006D01",
"c!	c #010500",
"d!	c #000A00",
"e!	c #002601",
"f!	c #011601",
"g!	c #00F701",
"h!	c #00D900",
"i!	c #00BD00",
"j!	c #01CA02",
"k!	c #00DC00",
"l!	c #01CC00",
"m!	c #01C600",
"n!	c #00FF1D",
"o!	c #00D514",
"p!	c #00B313",
"q!	c #01660F",
"r!	c #01430A",
"s!	c #01740F",
"t!	c #01D713",
"u!	c #00D613",
"v!	c #01D414",
"w!	c #01AD0F",
"x!	c #00920D",
"y!	c #013D00",
"z!	c #003D00",
"A!	c #012D01",
"B!	c #010901",
"C!	c #000C00",
"D!	c #011101",
"E!	c #00F201",
"F!	c #00C901",
"G!	c #01DC02",
"H!	c #00D201",
"I!	c #01DF00",
"J!	c #00FE18",
"K!	c #00FE1B",
"L!	c #00FF1B",
"M!	c #00EE17",
"N!	c #009811",
"O!	c #00D614",
"P!	c #00A312",
"Q!	c #007A11",
"R!	c #02440C",
"S!	c #026112",
"T!	c #00C714",
"U!	c #01F115",
"V!	c #00E914",
"W!	c #00D916",
"X!	c #00C913",
"Y!	c #00B811",
"Z!	c #00B611",
"`!	c #00800C",
" ~	c #013200",
".~	c #006500",
"+~	c #014E00",
"@~	c #000101",
"#~	c #001300",
"$~	c #019401",
"%~	c #01CD02",
"&~	c #01DD00",
"*~	c #01F501",
"=~	c #01F900",
"-~	c #00D901",
";~	c #00E400",
">~	c #00FF1C",
",~	c #00F618",
"'~	c #017011",
")~	c #01D815",
"!~	c #01CB14",
"~~	c #00E116",
"{~	c #01E815",
"]~	c #00E616",
"^~	c #00E715",
"/~	c #00D813",
"(~	c #01D312",
"_~	c #00990E",
":~	c #013001",
"<~	c #002701",
"[~	c #017002",
"}~	c #019602",
"|~	c #01FB01",
"1~	c #00EA00",
"2~	c #01DC01",
"3~	c #00B101",
"4~	c #01F819",
"5~	c #007F10",
"6~	c #00550C",
"7~	c #01E113",
"8~	c #01D114",
"9~	c #017513",
"0~	c #025C11",
"a~	c #02520E",
"b~	c #01400D",
"c~	c #016410",
"d~	c #00C316",
"e~	c #017110",
"f~	c #00F118",
"g~	c #00E717",
"h~	c #01E414",
"i~	c #00E015",
"j~	c #01EC16",
"k~	c #01C615",
"l~	c #01AA10",
"m~	c #004300",
"n~	c #013700",
"o~	c #002B00",
"p~	c #001100",
"q~	c #009802",
"r~	c #01A400",
"s~	c #01BE00",
"t~	c #01D401",
"u~	c #01E600",
"v~	c #01ED01",
"w~	c #01A300",
"x~	c #00FA18",
"y~	c #01A315",
"z~	c #01A516",
"A~	c #01D615",
"B~	c #01B015",
"C~	c #017013",
"D~	c #015E0F",
"E~	c #00E918",
"F~	c #01D817",
"G~	c #006F12",
"H~	c #01C815",
"I~	c #01F617",
"J~	c #01E813",
"K~	c #00E414",
"L~	c #01D512",
"M~	c #00B212",
"N~	c #00BE11",
"O~	c #020E01",
"P~	c #000002",
"Q~	c #001D02",
"R~	c #01B701",
"S~	c #00BA00",
"T~	c #01CF01",
"U~	c #01A501",
"V~	c #01A202",
"W~	c #01FD14",
"X~	c #01F216",
"Y~	c #01A515",
"Z~	c #00A212",
"`~	c #00AB12",
" {	c #01C913",
".{	c #019B13",
"+{	c #01A111",
"@{	c #017D15",
"#{	c #026D10",
"${	c #00EC18",
"%{	c #01DA16",
"&{	c #01720F",
"*{	c #01F219",
"={	c #00FD18",
"-{	c #00E917",
";{	c #01F015",
">{	c #00EF14",
",{	c #01D813",
"'{	c #00CF13",
"){	c #00D714",
"!{	c #013000",
"~{	c #012600",
"{{	c #011A00",
"]{	c #010502",
"^{	c #012C01",
"/{	c #009B01",
"({	c #01EF13",
"_{	c #01FA13",
":{	c #01D112",
"<{	c #01A611",
"[{	c #01A410",
"}{	c #029D11",
"|{	c #00C412",
"1{	c #009911",
"2{	c #008B11",
"3{	c #027813",
"4{	c #005610",
"5{	c #025A0F",
"6{	c #017411",
"7{	c #01EE16",
"8{	c #00DC17",
"9{	c #00CC17",
"0{	c #01F916",
"a{	c #01DE14",
"b{	c #01FF16",
"c{	c #00F214",
"d{	c #00D411",
"e{	c #012201",
"f{	c #010A00",
"g{	c #010D00",
"h{	c #011C00",
"i{	c #00A900",
"j{	c #00A200",
"k{	c #01D911",
"l{	c #01EC12",
"m{	c #01F515",
"n{	c #01F414",
"o{	c #01C112",
"p{	c #00D012",
"q{	c #018F10",
"r{	c #017613",
"s{	c #025B0F",
"t{	c #026E11",
"u{	c #00C719",
"v{	c #018816",
"w{	c #01F71A",
"x{	c #01F917",
"y{	c #01E412",
"z{	c #016702",
"A{	c #014500",
"B{	c #000501",
"C{	c #000801",
"D{	c #000400",
"E{	c #009900",
"F{	c #018C02",
"G{	c #015802",
"H{	c #025F01",
"I{	c #00B110",
"J{	c #00FA15",
"K{	c #00DD12",
"L{	c #01A510",
"M{	c #00B90F",
"N{	c #00D913",
"O{	c #00E812",
"P{	c #00C113",
"Q{	c #017E15",
"R{	c #027914",
"S{	c #007E16",
"T{	c #018C13",
"U{	c #01AD15",
"V{	c #01FE1B",
"W{	c #00FD17",
"X{	c #00F315",
"Y{	c #00F617",
"Z{	c #01F912",
"`{	c #000603",
" ]	c #012501",
".]	c #009800",
"+]	c #018A00",
"@]	c #006600",
"#]	c #009A0F",
"$]	c #01B311",
"%]	c #01E212",
"&]	c #00CB12",
"*]	c #01D413",
"=]	c #027714",
"-]	c #00530F",
";]	c #012D0A",
">]	c #00500C",
",]	c #027415",
"']	c #016911",
")]	c #00D818",
"!]	c #02FC19",
"~]	c #01EF16",
"{]	c #00ED15",
"]]	c #00E112",
"^]	c #027101",
"/]	c #010302",
"(]	c #002D00",
"_]	c #008300",
":]	c #013002",
"<]	c #00AB0F",
"[]	c #00950F",
"}]	c #00A210",
"|]	c #008B10",
"1]	c #00B210",
"2]	c #00DA12",
"3]	c #01CD13",
"4]	c #01B013",
"5]	c #01AE14",
"6]	c #00550E",
"7]	c #02470E",
"8]	c #016D13",
"9]	c #017615",
"0]	c #01A214",
"a]	c #01FC1C",
"b]	c #00FB15",
"c]	c #00DB14",
"d]	c #005B01",
"e]	c #011901",
"f]	c #002300",
"g]	c #014201",
"h]	c #013B00",
"i]	c #007502",
"j]	c #00B701",
"k]	c #017701",
"l]	c #028601",
"m]	c #009C0F",
"n]	c #00950D",
"o]	c #017F0F",
"p]	c #019E11",
"q]	c #00CC12",
"r]	c #00DA14",
"s]	c #01A511",
"t]	c #017514",
"u]	c #013E0D",
"v]	c #026614",
"w]	c #008515",
"x]	c #00F41D",
"y]	c #01FA17",
"z]	c #00EB16",
"A]	c #00D712",
"B]	c #001E00",
"C]	c #011301",
"D]	c #01B101",
"E]	c #007D01",
"F]	c #005800",
"G]	c #005F00",
"H]	c #01770F",
"I]	c #00810F",
"J]	c #007E0F",
"K]	c #019211",
"L]	c #019F10",
"M]	c #00B412",
"N]	c #01A916",
"O]	c #027514",
"P]	c #005810",
"Q]	c #006012",
"R]	c #02510E",
"S]	c #027114",
"T]	c #016D14",
"U]	c #006B12",
"V]	c #00D317",
"W]	c #01FC16",
"X]	c #00EA14",
"Y]	c #01E614",
"Z]	c #00CC13",
"`]	c #00C712",
" ^	c #00DC12",
".^	c #002400",
"+^	c #000D00",
"@^	c #007600",
"#^	c #01A401",
"$^	c #003001",
"%^	c #00850D",
"&^	c #008E10",
"*^	c #00880F",
"=^	c #00A710",
"-^	c #00B713",
";^	c #00C413",
">^	c #01DB14",
",^	c #019D15",
"'^	c #016F13",
")^	c #016513",
"!^	c #00540F",
"~^	c #005B10",
"{^	c #018918",
"]^	c #017C15",
"^^	c #007613",
"/^	c #00660F",
"(^	c #026D14",
"_^	c #025D12",
":^	c #01DA17",
"<^	c #01FE1C",
"[^	c #00EA17",
"}^	c #00DC14",
"|^	c #00D713",
"1^	c #00CE11",
"2^	c #000401",
"3^	c #018001",
"4^	c #023700",
"5^	c #00A912",
"6^	c #01AF12",
"7^	c #02C613",
"8^	c #01D715",
"9^	c #01F315",
"0^	c #009515",
"a^	c #017C16",
"b^	c #018D18",
"c^	c #018E19",
"d^	c #019B1C",
"e^	c #018217",
"f^	c #01750E",
"g^	c #01790F",
"h^	c #006610",
"i^	c #01F418",
"j^	c #01FF1B",
"k^	c #00E816",
"l^	c #00DC13",
"m^	c #00CF12",
"n^	c #00B810",
"o^	c #003801",
"p^	c #002100",
"q^	c #003802",
"r^	c #003A01",
"s^	c #017C02",
"t^	c #00C411",
"u^	c #00AD13",
"v^	c #019A11",
"w^	c #009D13",
"x^	c #00E115",
"y^	c #01C415",
"z^	c #018317",
"A^	c #019B1B",
"B^	c #018518",
"C^	c #019E1B",
"D^	c #00B716",
"E^	c #02F316",
"F^	c #01EB16",
"G^	c #00C414",
"H^	c #00DA13",
"I^	c #00FC17",
"J^	c #01FC17",
"K^	c #01FC18",
"L^	c #00E716",
"M^	c #01D714",
"N^	c #00B911",
"O^	c #00B213",
"P^	c #009B0E",
"Q^	c #018601",
"R^	c #003E00",
"S^	c #006C01",
"T^	c #016A01",
"U^	c #01A811",
"V^	c #009611",
"W^	c #019811",
"X^	c #00F516",
"Y^	c #01EC15",
"Z^	c #00A913",
"`^	c #028717",
" /	c #017515",
"./	c #017B16",
"+/	c #017F16",
"@/	c #009113",
"#/	c #00DD15",
"$/	c #01DB15",
"%/	c #00DE16",
"&/	c #00E916",
"*/	c #01F919",
"=/	c #01FE15",
"-/	c #01E415",
";/	c #01B113",
">/	c #025602",
",/	c #006602",
"'/	c #007500",
")/	c #014400",
"!/	c #00C512",
"~/	c #00AC13",
"{/	c #00BD11",
"]/	c #00F216",
"^/	c #00F017",
"//	c #01F417",
"(/	c #007310",
"_/	c #016A13",
":/	c #01620E",
"</	c #00CE13",
"[/	c #01C813",
"}/	c #00D515",
"|/	c #00E415",
"1/	c #01A90F",
"2/	c #016B00",
"3/	c #00E000",
"4/	c #01B600",
"5/	c #001C01",
"6/	c #017C01",
"7/	c #00C013",
"8/	c #00B815",
"9/	c #00D215",
"0/	c #01EB18",
"a/	c #01DB16",
"b/	c #00E915",
"c/	c #01D614",
"d/	c #01690F",
"e/	c #017C10",
"f/	c #00CA13",
"g/	c #00DD14",
"h/	c #01E116",
"i/	c #00F916",
"j/	c #01F815",
"k/	c #01F317",
"l/	c #00F415",
"m/	c #00E814",
"n/	c #00C111",
"o/	c #01D400",
"p/	c #008402",
"q/	c #019001",
"r/	c #01A002",
"s/	c #04BA04",
"t/	c #0BF61F",
"u/	c #0BF520",
"v/	c #0CEE21",
"w/	c #0CCD1E",
"x/	c #0BB91E",
"y/	c #0BB71C",
"z/	c #0BBC1E",
"A/	c #0CDB1F",
"B/	c #0CF521",
"C/	c #0BCE20",
"D/	c #0BC21F",
"E/	c #0BDD1F",
"F/	c #0CF021",
"G/	c #0AC71D",
"H/	c #046311",
"I/	c #046B12",
"J/	c #0BC41D",
"K/	c #0CF821",
"L/	c #0CDF1E",
"M/	c #0CE821",
"N/	c #0CF020",
"O/	c #0CF721",
"P/	c #0BF521",
"Q/	c #0CE01F",
"R/	c #0CEE20",
"S/	c #0CF421",
"T/	c #0BE91D",
"U/	c #0CE71F",
"V/	c #0CF320",
"W/	c #0CFA20",
"X/	c #0CE31F",
"Y/	c #0CC71E",
"Z/	c #0BE61C",
"`/	c #00B601",
" (	c #01DD02",
"  . + @ # $ % & * = - ; > , ' ) ! ~ { ] ^ / ( _ : < [ } | ) 1 2 3 4 5 6 7 8 9 0 a b c ) d e ) f g h i j k l m n o l p q r s t u ",
"v w x y z A B C D E F G H I J K L M N O P Q R S T U V W X Y Z `  ...+.@.#.$.%.&.*.=.-.;.>.,.'.).'.!.~.{.].^./.(._.:.<.[.l }.|.1.",
"2.F 3.4.5.6.7.8.9.0.a.b.c.d.e.f.g.h.i.j.k.l.m.n.h.o.p.q.r.s.t.u.v.w.x.y.z.A.B.C.D.E.F.,.,.G.H.I.H.J.K.L.M.N.O.x P.Q.R.S.T.U.. H ",
"V.W.X.Y.3.= Z.`. +.+++@+#+W.e.$+%+&+*+=+-+;+>+O ,+'+)+!+~+{+]+^+/+(+_+:+<+[+}+|+1+2+/+3+G.G.,.4+).5+6+7+8+9+X.0+^.a+b+c+d+e+f+m ",
"g+h+i+j+k+l+# m+n+o+p+q+r+s+t+u+v+w+x+y+z+A+B+C+D+E+F+G+H+I+J+K+L+M+N+O+P+Q+R+S+T+U+V+W+3+,.).G.X+Y+Z+`+ @.@+@F g+@@#@$@%@&@*@6+",
"=@l -@;@q+>@,@'@)@!@~@{@]@^@/@(@_@:@<@[@}@|@1@2@3@4@5@6@7@8@9@0@a@b@c@h.d@e@f@g@h@i@+.j@J.'.).,.'.k@. ].L.l@m@n@o@p@q@r@c.s@].m@",
"+ t@8+u@v@w@x@y@z@A@B@C@D@E@F@G@|+H@I@J@K@X L@M@N@O@P@Q@R@E+S@T@U@V@W@X@Y@Z@`@5@ #.#+#K G.,.@#;.H.,.##0+$#%#&#*#7+8+m@=#-#;#>#,#",
"'#)#W.!#~#{#]#^#/#(#_#:#<#[#}#|#1#2#3#4#5#6#7#8#9#Q@0#6@a#b#c#d#e#f#g#h#i#j#k#l#m#n#o#p#q#r#M+s#t#u#v#w#4.a+x#y#z#A#B#C#D#E#F#G#",
"7+H#I#J#K#L#M#N#O#O#P#Q#/#R#S#T#U#V#W#X#Y#Z#`# $.$q.+$F+@$Z##$$$:+%$&$*$=$-$;$0#>$,$'$)$!$~$V+{$]$^$/$($6._$k :$<$[$}$|$= 0+1$h+",
"2$3$4$4$5$6$7$8$9$0$N#a$b$c$d$e$f$g$h$i$j$k$l$m$n$o$p$ #q$r$s$t$u$v$w$x$y$z$A$B$.$8#9#C$D$E$F$G$p#H$I$J$K$%@L$M$X.N$O$P$Q$R$^.M.",
"S$T$U$V$W$X$Y$Z$`$ %.%+%@%#%$%%%&%*%=%-%;%>%,%'%)%!%O@~%{%s$~%]%A$^%/%{%q.(%_%:%'%,%<%,%[%}%S+|%1%2%3%4%5%6%7%8%9%0%a%`+Q$t@b%#@",
"A#c%j d%e%&#f%g%h%i%j%k%l%m%n%o%p%q%r%s%t%u%v%w%x%y%{%h@z%A%h@B% #C%n$0#D%D$E%{%^%F%G%)%H%I%J%K%L%M%N%O%P%Q%%@R%S%T%U%2.V%W%X%Y%",
"/.t@Z%_$|$`% &k%z@.&+&o+@&#&$&%&&&*&=&-&;&8#n$>&,&'&)&!&;$~&~%{&]&]&^&C%H%8#'%/&(&(%_&w%:&<&[&}&|&1&t@|$P.2&d+h+3&4&%@q ;#5&6&7&",
"8&N%9&0&a&b&c&d&+&C@e&f&g&h&)+i&-&j&k&l&m&n&o&C$p&q&r&D%s&A%Z#C%F+t&u&:%v&w&>$x&y&w&z&C$z%o$I%i&A&B&<.C&D&= .@R$E&- y Q$].F&G&H&",
"U%I&J&M.K&L&*@M&]@n+N&O&P&Q&R&S&T&U&u%V&W&~%N@X&O@Y&Z&`&~% *.*+*@*_%8##*$*o$%*/%&*@*q.z%**n$_%=*-*|@b+;*'#>*,*'*P%)*!*k ~*{*]*8&",
"M.^*_$/*(*_*:*x#<*D@[*}*e&|*1*2*3*4*h@q&5*h@6*l#0#k#7*n$+$~%z&t&8*A%/&)&)%9*h@A$0*a*x%b*{&c*q.d*e*f*3&g*n@h*i*j*k*:$l*U%m*n*o*8&",
"y {.-@p*b&q*5$r*L&s*t*u*v*.%w*x*y*z*'&8*,%q.A*B*Z#C*D*E*S+>&;$%*w&.*S+q.F*h@G*9#H*I*/&B%J***+$!&K*L*= M.=#M*N*O*E _*P*U%Q*/.F#}.",
"E#R*S*T*U*j+C V*W*X* +Y*9$+&Z*`* =.=+=@=#=$=%=&=C$@**===/%.*-=;=>=]&)&,=**h@'=5@Q@t$)=z%>=`&==E*!=~=!*;*{=]=^=/=m+(=_=>#:=0+<=[=",
"8&2.}=,#n@_*|=<*1=2=3=4=5=6=7=8=9=0=w&>&a=b=r&N@v%!%c=d=c=b*e=E*e=:%f=a=z%!%g=h=%=a*i=h@O@G+j=Q@k=l=m=m+n=o=p=q=r=s=t=u=P%- {=N%",
"v=w=E j x=y=Z.z=A=B=C=D=@%:#E=F=G=H=I=**A*J=H%8#u%K=N@S+n$L=@*%*!&M=z%;$!&,$n&A%y$/%c=t$N=O=P=**Q=S&k .+R=# S=T=U=)@V=S*W=b%X=m ",
"Y=L.Z=a%`=-@P* -.-X$+-b$@-#-$-%-R&&-_%]&L=w&w&m&*-=-a*,=/%)&--{&y$<&5*b*9#;-y$>-%*b=!%8*D%]&`@,-'-)-U*!-~-K#{-]-^-/-(-X$M&_-n l*",
":-z#<-E [-Z=}-:*|-_*1-P#2-3-4-}#5-v%6-*- *7->&8-H%9-==0-N@V&_&n&*-%*i=S+]&a-F+b-V&/&]&a*c-**w&d-e-f- &g-h-[-W*i-j-k-l-U=m-p=n-o-",
"q*I#x=z#p-`%c&z=G#q-r-s-}*t-u-v-w-a*S+>&A%E%I*m&/%x-:&y-z-,=_%A-+*A%A-A$C%B-m#m&m&(&==n&C-D-'-z%.=E-F-G-/=V*.+H-I-5$J-K-M#m+n-q@",
"L-p=l@9%# &#O.p=p@ -`=[*M-N-O-P-Q-L=A-`&N@R-D-c=]&S-/&J=N@I=T-*-I%6-U-`&V-t&8#@=A-w&i=z%**+*W-J%c-X-Y-Z-`- ;g%.;]-+;@;#;V*0.*@=#",
"$;/*Z=Z=e%k*U%%;O%n@!#&;o+*;=;-;T+w&,=I%;;>;`&,;';<&c=J%I%6-y$,=);E%!;S+$=u&+*S-E%~;%*b*{;];I%]&^;/;Y.(;g-_;:;<;[;};|;.;1;2;3;e+",
"4;k 5${-5;6;1$7;}-l*C&5$8;9;0;a;b;e=C*I%a*C->&B-#*Q=8*c;n&A-w&a;a;d;s&z%N@C$.#/&a*A-e;$=f;g;-$,;R-h;i;j;B Z-k;l;m;n;.;p+o;>@B p;",
"'#;#q;u@r;s;6.r;q;a+n-&#t;u;v;8#,=>$h@w;_%_%m$$=x;-$I%y;a*m&B-m&b***0#c=s${&_&'-z&z;b*y$%*b*A;_&B;C;D;E;};F;]@g%.+G;H;.+W*s*I;J;",
"K;W.L;M;L&N;K$O;P;,*T.<=W.}.Q;R;S;T;U;V;W;0#X;a*l&8-';c=:&Y;<&7-Z;`;]&C$b;t$N@ >_&.>+>y-@>8#_%#>9-$>%>&>k%m-*>=>[# %->!-;>p+|* +",
">>O*j G-,>h+'>)>w#!>M*4%4&~>{>]>^>/>`@ >==(>K=c=E+_>*=^>:>a**=J%<>>$[>$*}>==c=:&^>I%`@|>u%W A*1>4@2>3>4>5>6>m-7>.&8>D@9>0>a>->|;",
"]-z=.@Y-b>c>Z+d>e>f>g>h>'*i>j>k>V&l>t$m>]%g;n>o>p>q>r>o&s>_&==t>u>w&v>I%w&);w>b-w&^;x>*=y>,&z>w%_%A>B>C>+%D>E>&;F>~@G>H>I>q+T=i-",
"`=/*].}=^=p@.@8&2&J>K>L>M>N>O>P>H%J%Q>J%>;R>S>*=T>v%U>V>$=a*W>X>O==-Y&$=u%l&g;:&,&J%Y>b*<& >t$Z>`>`*G>e& ,8>.,+,@,#,D;r-$,(*;@Z-",
"%,A=z#5$8%<-R*&,Y=*,N;=,-,;,>, .A%===- >:&E+,,P=0*.=<&',),0*&*!,}>~,*={,w%0*b*'&],^,'&S-^>^>*=8-/,(,_,:,<,0.[,},|,1,S$P$X.2,4$3,",
"X.u@^-l;4,q;5,Y=Z=Z=P%%@m*6,0@7,8,9,0,a,`@I*$=b,c,&*d,e, >f,m>c=o#g,h,i,o&V-*=t$`@}>W;/>$=R-$=]&2*j,<;_;1;k-k,G>6$l,m,n,@+o,]#r+",
"p,U$3,^@q,5$G-(=@@9%m@r,G#s,t,j@:>9,u,v,,&b*w,}>c=x,:&y,o#z,A,^>B,0#k=q.A;}>C,W;m>9-}>W;D,}>*=>&E,F,`-T=G,H,&;;>T$I,J,F#t-K,j;~-",
"V$_=z=o-T%0%g+4.E&L,- s;o=Q.M,:+O=t$@=N,E+%=W&0#.*&*O,A$]&P,R-Q,r>+$6-I%b*R-a-x-';o#9-+=,&9-R-^>R,S,%,T,p=U,V,`-I&I$W,r=7$C@s*p;",
"2$X,6,0&n=Y,'*Z,6&`, '.'Z++'@'#'$'Q-%'b,&'*'R-S+8#Z#m&J%-$}>0* #'%Q@)%)%q.=':%m>*=S>W;=--'9-w&;'>','h%|*C p=t;a+'')'P*t-5=!'X$O%",
"*,~'{']'s;^'/'('_'R./':'N>5%<'['O=t$:&C-W l&m>E+@=#>a*}'y>*'Z;}>|'w&==*=>-9-=-%'*=';*=@=!,1'==2'3'4'x@g&5',>W=6'7'S%7.8'1-|*i;|$",
"9'-#<=|.0'a'b'c'~>d'e'J>f'g'h'i'}>r$p$y,&*D*j'.#}%k'l'm'**v%n'I%H%]&%*o'n$W;p'&-s>q'v%+=+=0*r' =s't'j-u'v's=x#P.m*g-w'|$x'a>y'c&",
"z'A'B'C'5%D'c'E'0'F'r@~'G'H'I'J'E**=K'L'z>*'*=$=*=M'c=N@n$w%y,x%F+t$ >d*P,N'a-N,O'P'Q';-W;a*R' =S'T'm-U'V'W't=X'Y'Z'`' )S$3,`..)",
"S.+)i*0'5%@)#)w#$)c+%)&)+'*)(+=)-)$'z>d*;-;)>)T>i=h@@$,)a*n'o#)+-'N@a=.$.#')';q'))**B-+=!):&o%~){)])^)N-<,/-@+o,v@/)4=`-()K;5;(=",
"G&_):)<)D'[)})5%|)2&1)f+2)3)4);.5)6);-x-W;7)8)_&=-';D,O'9)0)v%o&a)(%%=S-^>}>Q,b)c)D*>&k$t$,=d)e)/@f)g)};h)i)j)N#k)C@l)E@7.W$b>,>",
"m)n)o)p)q)5%j*3%r)R.s)[=h*t)k@,.u)v)w)3@&*x)y)8#m>o$z)p&W u%A)W B)6-C)m>=-,&D)s>v%E)u%6->&F)G)H)I)J)3$~-2;_;l)@%K)#&L)+,M;M)N);@",
"0'O)P)Q%Q)R)S)q)('T)c+E'U)V)G.4+W)X)@=Y)D*-;x,(%}>:&Z)o&`) !D)!&.$m&!,',.!y,&*+!B;V>@!#!$!%!&!*!=!-!B#x@;!>!,!5''!/)e&x@g))!!!~!",
"4.(${!]!1)%)Q%6&m)2&^!/!(!_!,.:!G.<![!}!e,|!1!-;=-@$2!(%v%R>O=!,.#3!/>@=*=.!x-4!y,0)x-5!6!7!8!9!0!a!L.)!)@1;l+b!V=c!d!e!f!&>u*j;",
"W.q)g!h!E&h*i!j!N>'>k!l!m! ''.n!'.o!.>W;w-p!U+q!0*,&i=]&v%T>D,$*r!+=W;O,z>}>@=Q'$'u%s!t!u!v!y+&!w!x!#,y!z!X$k-t=J#A!4>7$@%B!C!D!",
"q X%v#E!##n P.F!K>G!K>H!p)I!J!K!L!M!',s>N!O!P!Q!a*a*R!x%w%B).!c=O@G*E$w%<&X&6-T>S!N,T!U!V!W!X!Y!Z!`!y!&  ~.~# +~a.(-4=@~/)N&#~N&",
"$~%~&~*~=~M*%)v -~-~P)'>M*;~H.>~4+,~'~g;)~L !~I+,&^>m$Z#}>s>0,r$A%a,';+=I+1!V;F$W i$~~{~]~^~/~(~z+_~(;:~V,V,.)<;},E@<#d!C=C@d!<~",
"[~m*}~6%|~1~2~i*('S.3~f+%@-~H.I.H.4~5~6~7~J 8~..9~0~a~.=';,-C,,=b~m>9)c~}+d~x;S-e~f~g~h~i~j~o!k~y+l~j-C>m~n~H;N)3-o~p~u*% 9$@-C!",
"N.q~r~s~t~u~v~4%h*s;w~t@D&-#>,G.t#x~y~z~P+A~B~=%C~^;'$^>D~Q-+>p$x%7#w%c~E~F~G~s>H~'.I~J~K~A.L~R M~N~%,G;&;0.C=O~t-->k)0$P~b$C!Q~",
"n@^*b%R~S~v n)T~Z+U~V~8&;#S.r#t#W~X~Y~Z~`~ {.{+{@{';`@7#9-A)+*N@z&*=,-#{${%{#$&{*{,.={-{j>;{>{,{'{){ &.+j%!{}*O&~{{{(#e&]{5=Y$^{",
"8%/{4&e+%@l,Z,t)q)_'1$U.2.i>({>,_{:{<{[{}{|{1{2{3{4{:%o#W;Q'8#!;]&5{y$6{7{8{Q-9{X+G.).0{a{X~b{t#c{d{l-e{~!f{g{Y$&>l%5>4>h{H>e!~-",
"}.d+i{1$j{t@/.P%G'K.g+<-*#'#k{l{m{n{o{3#W@p{S@q{r{E+0,Q>e,W ==0#y;s{$'t{b@u{v{w{'.).G.,.K x{X+@#J!y{z{3$A{B{+%C{D{C![#5'[*l) ;>>",
"H 3~2.y x Q.E{Y=F{{.i+[;G{H{Y!I{:+J{K{L{M{N{O{P{Q{);,&a-9)a;!+o&b*V>R{S{'~T{U{!.V{t#@#).W{X{Y{@#b{Z{n,`++~`{e&}*u*i->@ ]:;V,@+D ",
",*y R%U.n-l .]0%;*+]@]K-A{u;#]m.$]'{%]&]N~X!%+*]=]-]'&P'x;,=+*;]>]&*N@y>,]'])]I.I.4+G.t#!]~]{]<'W+]]q ^]l-R#/]k%V,B=1-(]B %>m+x#",
"> 4%E#)*!*n*].n@)*U~_]0.:]@]<][]}]|]1]2]3]4]C+5]i,6]v%`@#=7]a=]&&*L'8]x%d*9]0]a]:!>~'.4+J!b]{]c@c]o{p*d]>@e]D!f]w'g]!!h]J;.,>>i]",
"w C'j]w~0&o-@@k]<$l]>*C v'V=m]n]2*o]p]q]r]M~s]=$t]u]{&P'e-^>t$q.%*h=W v]Z)a,w]x]H.4+L!4+@#y]z]g#'{A]Y.h]9>(#B]C@C]t-3-W'q=l;Y-z#",
"= m D]1$)#E]p@k]u;F]G] ;#%*>H]I]J]K]L]M]=)q]R N]O]P]Q]R]W;0~8#m&,-S]g;9-T]o#U]V]X+4+n!4+W]X]Y]Z]`] ^s+|*.^ ,+^5=8$k)& #+b!@^U.#^",
"7%Z+l E{i{G#G-7+|-.)j+$^H>5'%^&^*^=^O -^;^e.>^,^'^)^!^c=*=~^{^x;x-]^^^/^8*(^_^:^4+4+<^).[^f#}^U@|^1^t=Q&G>w'g%P~2^e] ;@]+]3.r,6;",
"G t q R%!*3&/=.-p@3^p;4^G;H,=^5^k&6^7^p#8^M+9^0^3@Y)a^b^s>T>c^d^e^e-f^u!g^g;h^i^j^4+X+G.k^8~l^3]m^n^o^:,E>[$j+C=p^q^r^X'2$0&3.Y=",
"s^p@T*<-9+3.l*U*z#G,+,)!3-y#t^u^v^w^g#a{x^$+_+y^'~8]z^A^^>J%B^C^'^=-D^E^F^G^H^X+G.I^J^G.K^L^M^N^O^P^N-~!m~y#T.Q^2=o~4>R^k+V%{=N%",
"Y-z#S^K;L.q R$z=4,T^'@3$;>r=h$U^V^W^M I~X^x{Y^i~Z^D~x;`^ //>./+/g;@/ {#/%.$/%/&/*/` =/).,.4)-/;/5^L]<*>/,/`=N*X%f+t=H>g%W'h+S%G-",
"#^k .)'/0%O;9&0&'/+]@@4,)/G,7!!/~/*&{/$.]/^///h'_+1&(/@!{^ /_/:/&+</q]t.[/Z]}/|/m{G.y]M+3+t#X{T!5^1/2/K&F-<$ @4%3/4/~*X'V=r=N)5/",
"E#H $~6/T*C#].q N%h+M.6/9+E#M+o.T!7/8/N 9/g~0/a/b/U!c/d/v% !e/f/f.g/t.!~i#h/U!i/j/J{k//+l/4)=/m/y.n/V%E s=W*p=%#D#e>:'o/E&p-/*~#",
"p/T.b+Q$/*9+'#p*q/l*W.r/#^s/t/u/v/w/x/y/z/A/B/C/D/E/F/G/H/I/J/K/c L/M/B/N/O/P/Q/Q/R/S/T/U/V/W/X/Y/Z/i l `+T$7.^@k]`/ (H!A'f+3.q-"};
//**********************************************************************************************************
enum FormMainIDs
{
		mainProgress,
		mainVolume,
		mainLooped,
		mainRandom,
		mainPrevious,
		mainPlay,
		mainPause,
		mainStop,
		mainNext,
		mainAddFile,
		mainAddFolder,
		mainEncode,
		mainPlayback,
		videoPlayer
};
//**********************************************************************************************************
#define max(a,b) (a>b?a:b)
#define min(a,b) (a<b?a:b)
//**********************************************************************************************************
FormMain * g_formMain;
extern FormPlaylist * g_formPlaylist;
extern FormEncode * g_formEncode;
//**********************************************************************************************************
BEGIN_EVENT_TABLE( FormMain, wxFrame)
	EVT_KEY_DOWN(									FormMain::_onFormKeyDown)
	EVT_CHECKBOX(					mainLooped,		FormMain::_onCBLoopedClick)
	EVT_CHECKBOX(					mainRandom,		FormMain::_onCBRandomClick)
	EVT_BUTTON(						mainPrevious,	FormMain::_onBtnPreviousClick)
	EVT_BUTTON(						mainPlay,		FormMain::_onBtnPlayClick)
	EVT_BUTTON(						mainPause,		FormMain::_onBtnPauseClick)
	EVT_BUTTON(						mainStop,		FormMain::_onBtnStopClick)
	EVT_BUTTON(						mainNext,		FormMain::_onBtnNextClick)
	EVT_BUTTON(						mainAddFile,	FormMain::_onBtnAddFileClick)
	EVT_BUTTON(						mainAddFolder,	FormMain::_onBtnAddFolderClick)
	EVT_BUTTON(						mainEncode,		FormMain::_onBtnEncodeClick)
	EVT_COMMAND_SCROLL(				mainProgress,	FormMain::_onMediaBarChange)
	EVT_COMMAND_SCROLL(				mainVolume,		FormMain::_onVolumeControlChange)
	EVT_MOVE(										FormMain::_onMoveWindow)
	EVT_CLOSE(										FormMain::_onClose)
	EVT_ICONIZE(									FormMain::_onIconize)
END_EVENT_TABLE()

#define jbBITMAP(name) wxBitmap(wxT(#name), wxBITMAP_TYPE_PNG_RESOURCE)
bool FormMain :: sm_toPlay = false;
bool FormMain :: sm_playingVideo = false;
JokerCtrl * FormMain :: sm_videoPlayer = NULL;
extern FormVideo * g_formVideo;
bool FormMain :: sm_stopping = false;
//**********************************************************************************************************

 FormMain :: FormMain()
	:	wxFrame( NULL, wxID_ANY, wxT( "Joker's Player"), wxPoint( 0, 0), wxSize( 296, 185), 
				 wxMINIMIZE_BOX | wxSYSTEM_MENU | wxCAPTION | wxCLOSE_BOX),
		m_moveFile		( false),
		m_looped		( false),
		m_random		( false),
		m_stopping		( false),
		m_manualChange	( false),
		m_playingCD		( false),
		m_simpleDesign	( NULL),
		m_appDirectory	( NULL),
		m_playerThread	( NULL)
{
//	std::cout << "FormMain :: FormMain - Begin\n";
	m_appDirectory = new wxFileName( wxGetApp().argv[0]);
	m_log = new Log(  m_appDirectory->GetPath() + wxT( "/JokersPlayer.log"));
	g_formMain = this;
	m_container = new wxPanel( this, wxID_ANY, wxPoint( 0, 0), GetClientSize());
	m_mediaBar = new wxSlider( m_container, mainProgress, 0, 0, 1000, wxPoint( 0, 113), wxSize( 290, 18));
	m_mediaBar->Enable( false);
	m_volumeControl = new wxSlider( m_container, mainVolume, 0, 0, 100, wxPoint( 228, 55), wxSize( 54, 17));
	m_currentFile = new wxStaticText( m_container, wxID_ANY, wxEmptyString, wxPoint( 50, 78), wxSize( 3, 13));
	m_totalTime = new wxStaticText( m_container, wxID_ANY, wxEmptyString, wxPoint( 50, 94), wxSize( 3, 13));
	m_lblVolume = new wxStaticText( m_container, wxID_ANY, wxT( "Volume"), wxPoint( 228, 36), wxSize( 35, 13));
	m_lblNom = new wxStaticText( m_container, wxID_ANY, wxT( "Nom :"), wxPoint( 8, 78), wxSize( 37, 13));
	LblTemps = new wxStaticText( m_container, wxID_ANY, wxT( "Temps :"), wxPoint( 8, 94), wxSize( 33, 13));
	m_CBLooped = new wxCheckBox( m_container, mainLooped, wxT( "Boucle"), wxPoint( 8, 137), wxSize( 97, 17));
	m_CBRandom = new wxCheckBox( m_container, mainRandom, wxT( "Aleatoire"), wxPoint( 179, 137), wxSize( 97, 17));
//	wxInitAllImageHandlers();
	wxImage::AddHandler(new wxPNGHandler);
	wxImage l_images[5];
	l_images[0] = wxImage( m_appDirectory->GetPath() + wxT( "/rsc/PNGPrevious.png"));
	l_images[1] = wxImage( m_appDirectory->GetPath() + wxT( "/rsc/PNGPlay.png"));
	l_images[2] = wxImage( m_appDirectory->GetPath() + wxT( "/rsc/PNGPause.png"));
	l_images[3] = wxImage( m_appDirectory->GetPath() + wxT( "/rsc/PNGStop.png"));
	l_images[4] = wxImage( m_appDirectory->GetPath() + wxT( "/rsc/PNGNext.png"));
#ifdef WIN32
	m_btnPrevious = new ImageButton( m_container, mainPrevious, wxEmptyString, wxPoint( 0, 32), wxSize( 40, 40), g_buttonStyle);
	m_btnPrevious->SetImageEnable( l_images[0]);
	m_btnPlay = new ImageButton( m_container, mainPlay, wxEmptyString, wxPoint( 40, 32), wxSize( 40, 40), g_buttonStyle);
	m_btnPlay->SetImageEnable( l_images[1]);
	m_btnPause = new ImageButton( m_container, mainPause, wxEmptyString, wxPoint( 80, 32), wxSize( 40, 40), g_buttonStyle);
	m_btnPause->SetImageEnable( l_images[2]);
	m_btnStop = new ImageButton( m_container, mainStop, wxEmptyString, wxPoint( 120, 32), wxSize( 40, 40), g_buttonStyle);
	m_btnStop->SetImageEnable( l_images[3]);
	m_btnNext = new ImageButton( m_container, mainNext, wxEmptyString, wxPoint( 160, 32), wxSize( 40, 40), g_buttonStyle);
	m_btnNext->SetImageEnable( l_images[4]);

	m_btnAddFile = new ImageButton( m_container, mainAddFile, wxT( "Ajout fichier"), wxPoint( 0, 0), wxSize( 90, 32), g_buttonStyle);
	m_btnAddFolder = new ImageButton( m_container, mainAddFolder, wxT( "Ajout dossier"), wxPoint( 100, 0), wxSize( 90, 32), g_buttonStyle);
	m_btnEncode = new ImageButton( m_container, mainEncode, wxT( "Encoder"), wxPoint( 200, 0), wxSize( 90, 32), g_buttonStyle);
#else
	m_btnPrevious = new wxBitmapButton( m_container, mainPrevious, l_images[0], wxPoint( 0, 32), wxSize( 40, 40));
	m_btnPlay = new wxBitmapButton( m_container, mainPlay, l_images[1], wxPoint( 40, 32), wxSize( 40, 40));
	m_btnPause = new wxBitmapButton( m_container, mainPause, l_images[2], wxPoint( 80, 32), wxSize( 40, 40));
	m_btnStop = new wxBitmapButton( m_container, mainStop, l_images[3], wxPoint( 120, 32), wxSize( 40, 40));
	m_btnNext = new wxBitmapButton( m_container, mainNext, l_images[4], wxPoint( 160, 32), wxSize( 40, 40));

	m_btnAddFile = new wxButton( m_container, mainAddFile, wxT( "Ajout fichier"), wxPoint( 0, 0), wxSize( 90, 32));
	m_btnAddFolder = new wxButton( m_container, mainAddFolder, wxT( "Ajout dossier"), wxPoint( 100, 0), wxSize( 90, 32));
	m_btnEncode = new wxButton( m_container, mainEncode, wxT( "Encoder"), wxPoint( 200, 0), wxSize( 90, 32));
#endif
	
	m_trayIcon = new TaskBarIcon;

	m_playingFilesList = & m_filesList;
//	std::cout << "FormMain :: FormMain - End\n";
}

//**********************************************************************************************************

FormMain :: ~FormMain()
{
	if (m_playerThread != NULL)
	{
		m_playerThread->Cleanup();
		m_playerThread->Kill();
	}

	if (sm_videoPlayer != NULL)
	{
		sm_videoPlayer->Destroy();
	}
}

//**********************************************************************************************************

void FormMain :: Initialise()
{
//	std::cout << "FormMain :: Initialise - Begin\n";
	g_formPlaylist = new FormPlaylist( this);
	g_formPlaylist->Show();
	g_formEncode = new FormEncode( this);
	g_formEncode->Hide();

	m_filesList.clear();
	m_playedFiles.clear();
	m_playerThread = NULL;
	m_folder.clear();
	m_mediaName.clear();
	m_looped = false;
	m_stopping = false;
	m_fileStatus = fsNone;
	
	g_formVideo = new FormVideo( this);
#ifdef WIN32
	sm_videoPlayer = new JokerCtrl( g_formVideo, videoPlayer);
#else
	sm_videoPlayer = new JokerCtrl( g_formVideo, videoPlayer);
#endif
	sm_videoPlayer->Connect( videoPlayer, wxEVT_MEDIA_STOP, (wxObjectEventFunction)
							(wxEventFunction)(wxMediaEventFunction) & FormMain::_onMediaStop);
	sm_videoPlayer->Connect( videoPlayer, wxEVT_MEDIA_LOADED, (wxObjectEventFunction)
							(wxEventFunction)(wxMediaEventFunction) & FormMain::_onMediaLoaded);

	_readCfgFile( m_appDirectory->GetPath() + wxT( "/JokersPlayer.cfg"));

	int l_nbParams = wxGetApp().argc;
	if (l_nbParams > 1)
	{
//		std::cout << "Params : " << l_nbParams << "\n";
		wxString l_argument;
		for (int i = 1 ; i <= l_nbParams ; i++)
		{
			l_argument = wxGetApp().argv[i];
//			std::cout << l_argument << "\n";
			_addFile( l_argument);
		}
		if (m_filesList.size() > 0)
		{
			SetFile( m_filesList[0], true, true);
		}
		else if (m_vidFilesList.size() > 0)
		{
			SetFile( m_vidFilesList[0], true, true);
		}
		else if (m_cdFilesList.size() > 0)
		{
			SetFile( m_cdFilesList[0], true, true);
		}
	}
//	std::cout << "FormMain :: Initialise - End\n";
}

//**********************************************************************************************************

void FormMain :: SetSimpleDesign( SimpleDesign * p_sd)
{
//	std::cout << "FormMain :: SetSimpleDesign - Begin\n";
	if (p_sd == NULL)
	{
		return;
	}
	m_simpleDesign = p_sd;

	m_container->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_container->SetForegroundColour( m_simpleDesign->m_1stColor);
	m_currentFile->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_totalTime->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_lblNom->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	LblTemps->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_lblVolume->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_totalTime->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_currentFile->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_CBLooped->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_CBRandom->SetForegroundColour( m_simpleDesign->m_1stTxtColor);

	m_btnAddFile->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_btnAddFolder->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_btnEncode->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_btnPrevious->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_btnPlay->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_btnPause->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_btnStop->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_btnNext->SetBackgroundColour( m_simpleDesign->m_1stColor);
	
#ifdef WIN32
	m_btnAddFile->SetColours( m_simpleDesign->m_btnColours);
	m_btnAddFile->SetFontColours( m_simpleDesign->m_btnFontColours);
	m_btnAddFolder->SetColours( m_simpleDesign->m_btnColours);
	m_btnAddFolder->SetFontColours( m_simpleDesign->m_btnFontColours);
	m_btnEncode->SetColours( m_simpleDesign->m_btnColours);
	m_btnEncode->SetFontColours( m_simpleDesign->m_btnFontColours);
	m_btnPrevious->SetColours( m_simpleDesign->m_btnColours);
	m_btnPlay->SetColours( m_simpleDesign->m_btnColours);
	m_btnPause->SetColours( m_simpleDesign->m_btnColours);
	m_btnStop->SetColours( m_simpleDesign->m_btnColours);
	m_btnNext->SetColours( m_simpleDesign->m_btnColours);
#else
	m_btnAddFile->SetForegroundColour( m_simpleDesign->m_btnFontColours[jiENABLE]);
	m_btnAddFolder->SetForegroundColour( m_simpleDesign->m_btnFontColours[jiENABLE]);
	m_btnEncode->SetForegroundColour( m_simpleDesign->m_btnFontColours[jiENABLE]);
#endif

	g_formPlaylist->SetSimpleDesign( m_simpleDesign);
	g_formEncode->SetSimpleDesign( m_simpleDesign);

	Refresh();
//	std::cout << "FormMain :: SetSimpleDesign - End\n";
}

//**********************************************************************************************************

bool FormMain :: LoadFile( const wxString & p_file)
{                                                   
	std::cout << "FormMain :: LoadFile - Begin\n";
	if (m_playerThread != NULL)
	{
		std::cout << "FormMain :: LoadFile - Thread not Null\n";
		m_playerThread->Cleanup();
		m_playerThread->Wait();
		m_playerThread->Delete();
		m_playerThread = NULL;
	}
	
	if (p_file.empty())
	{
		return false;
	}

	if (IsVideo( p_file))
	{
		std::cout << "FormMain :: LoadFile - Video\n";
		m_playingFilesList = & m_vidFilesList;
		if ( ! sm_videoPlayer->Load( p_file))
		{
			std::cout << "Can't load " << p_file << "\n";
			return false;
		}
		sm_playingVideo = true;
		return true;
	}
	else
	{
		sm_playingVideo = false;
		std::cout << "FormMain :: LoadFile - Not Video\n";
		if (IsMedia( p_file))
		{
			m_playerThread = new AudioPlayerThread;
			m_playingFilesList = & m_filesList;
		}
		else
		{
			m_playerThread = new CDPlayerThread;
			m_playingCD = true;
			m_playingFilesList = & m_cdFilesList;
		}
		if (m_playerThread->LoadMedia( p_file))
		{
	//		std::cout << "FormMain :: LoadFile - End\n";
			return true;
		}
	}
	Log::LogMessage( wxT( "FormMain :: LoadFile - Can't load ") + p_file);
	return false;
}

//**********************************************************************************************************

void FormMain :: EndOfMedia()
{
//	std::cout << "FormMain :: EndOfMedia - Begin\n";
	if (m_stopping)
	{                        
		Log::LogMessage( "FormMain :: EndOfMedia - End - Already stopping");
		m_stopping = false;
		return;
	}
	m_fileStatus = fsNone;
	m_playerThread = NULL;
	m_mediaBar->SetValue( 0);
	_selectNext();
//	std::cout << "FormMain :: EndOfMedia - End\n";
}

//**********************************************************************************************************

void FormMain :: UpdateVideoSize( bool p_full, int p_width, int p_height)
{
//	std::cout << "FormMain :: UpdateVideoSize\n";
//	static_cast <VideoPlayerThread *>( m_playerThread)->UpdateVideoSize( p_width, p_height);
}

//**********************************************************************************************************

void FormMain :: FastForward()
{
//	std::cout << "FormMain :: FastForward\n";
	m_mediaBar->SetValue( m_mediaBar->GetValue() + 3);
	if (m_playerThread != NULL && ! m_playerThread->IsUpdatingBar())
	{
		m_playerThread->SetPosition( m_mediaBar->GetValue());
	}
	else if (sm_playingVideo)
	{
//		m_videoPlayer->Seek( );
	}
}

//**********************************************************************************************************

void FormMain :: FastBack()
{
//	std::cout << "FormMain :: FastBack\n";
	m_mediaBar->SetValue( m_mediaBar->GetValue() - 3);
	if (m_playerThread != NULL && ! m_playerThread->IsUpdatingBar())
	{
		m_playerThread->SetPosition( m_mediaBar->GetValue());
	}
	else if (sm_playingVideo)
	{
//		m_videoPlayer->Seek( );
	}
}  

//**********************************************************************************************************

void FormMain :: SetFile( const wxString & p_file, bool p_loadIt, bool p_playIt)
{
//	std::cout << "FormMain :: SetFile - Begin - [" << p_file << "]\n";
	if (p_file.empty())
	{           
		Log::LogMessage( "FormMain :: SetFile - End - Void file name");
		return;
	}
	if (m_fileStatus == fsNone)
	{
		m_mediaName = p_file;
		m_fileStatus = fsInitialised;
		std::cout << "FormMain :: SetFile - Initialised\n";
	}

	if (p_loadIt && m_fileStatus == fsInitialised && LoadFile( p_file))
	{
		m_fileStatus = fsLoaded;
		std::cout << "FormMain :: SetFile - Loaded\n";
	}

	if (p_playIt && m_fileStatus == fsLoaded)
	{
		sm_toPlay = true;
		wxFileName l_fileName( p_file);
		if (l_fileName.GetExt().MakeLower() != wxT( "mp3"))
		{
			m_displayedMediaName = l_fileName.GetName();
			sm_videoPlayer->SetLabel( m_displayedMediaName);
		}
		else
		{
#ifndef WIN32
			TagLib::FileRef l_file( p_file.c_str());
			TagLib::Tag * l_tag = l_file.tag();
			m_displayedMediaName = wxString( l_tag->title().toCString(), wxConvLibc);
#endif
		}
		m_currentFile->SetLabel( m_displayedMediaName);
		SetLabel( wxT( "Joker's Player - ") + m_displayedMediaName);
		if (IsIconized())
		{
#ifdef WIN32
			m_trayIcon->SetIcon( wxIcon( Joker_xpm), wxT( "Joker's Player - ") + m_displayedMediaName);
#else
			m_trayIcon->SetIcon( wxIcon( Joker_xpm, wxBITMAP_TYPE_XPM), wxT( "Joker's Player - ") + m_displayedMediaName);
#endif
		}
		if (m_playerThread != NULL)
		{
			m_totalTime->SetLabel( m_playerThread->GetMediaTime());
			Play();

			m_playedFiles.push_back( p_file);
			m_fileStatus = fsPlaying;
//			std::cout << "FormMain :: SetFile - Playing\n";
			m_mediaBar->Enable( true);
		}
	}
//	std::cout << "FormMain :: SetFile - End\n";
}

//**********************************************************************************************************

void FormMain :: PreviousFile()
{       
//	std::cout << "FormMain :: PreviousFile - Begin\n";
	if (m_playerThread == NULL && ! sm_playingVideo)
	{
		Log::LogMessage( "FormMain :: PreviousFile - End - Player thread null");
		return;
	}

	if (m_playedFiles.size() == 0)
	{
		return;
	}
//	std::cout << "FormMain :: PreviousFile - has files\n";
	m_mediaBar->SetValue( 0);
	bool l_wasPlaying = (m_status == STATUS_PLAY || m_status == STATUS_PAUSE);
	Stop();

	int l_index = m_playedFiles.Index( m_mediaName);
	m_playedFiles.RemoveAt( l_index);

	if (m_playedFiles.size() > 0)
	{
		wxString l_previous = m_playedFiles.Last();
		m_mediaBar->SetValue( 0);
//		std::cout << "FormMain :: PreviousFile - " << l_previous << "\n";
		l_index = m_playedFiles.Index( l_previous);
		m_playedFiles.RemoveAt( l_index);
		g_formPlaylist->SetSelected( l_previous);
		SetFile( l_previous, true, l_wasPlaying);
	}
	else
	{
		sm_videoPlayer->Hide();
	}
//	std::cout << "FormMain :: PreviousFile - End\n";
}

//**********************************************************************************************************

void FormMain :: Play()
{               
//	std::cout << "FormMain :: Play - Begin\n";
	if (m_playerThread == NULL && ! sm_playingVideo)
	{
		Log::LogMessage( "FormMain :: Play - End - Player thread null");
		return;
	}
	std::cout << "VideoPlayer : " << sm_videoPlayer << " - PlayerThread : " << m_playerThread << "\n";
	if (sm_playingVideo)
	{
		sm_stopping = false;
		std::cout << "coin !\n";
		sm_videoPlayer->Play();
		std::cout << "coin !\n";
		sm_videoPlayer->Show();
		g_formVideo->Show();
		std::cout << "coin !\n";
	}
	else if (m_playerThread != NULL)
	{
		m_playerThread->Create();
		m_playerThread->Run();
		m_playerThread->StartPlayback();
	}

//	std::cout << "FormMain :: Play - End\n";
	m_status = STATUS_PLAY;
}

//**********************************************************************************************************

void FormMain :: Pause()
{
//	std::cout << "FormMain :: Pause - Begin\n";
	if (m_playerThread == NULL && ! sm_playingVideo)
	{
		Log::LogMessage( "FormMain :: Pause - End - Player thread null");
    	return;
	}
	if (sm_playingVideo)
	{
		sm_videoPlayer->Pause();
	}
	else if (m_playerThread != NULL)
	{
		m_playerThread->PausePlayback();
	}
	m_status = STATUS_PAUSE;
//	std::cout << "FormMain :: Pause - End\n";
}

//**********************************************************************************************************

void FormMain :: Stop()
{
//	std::cout << "FormMain :: Stop - Begin\n";
	if (m_playerThread == NULL && ! sm_playingVideo)
	{
		Log::LogMessage( "ERROR : FormMain :: Stop - Player thread null");
		return;
	}
	m_stopping = true;
	if (m_playerThread != NULL)
	{
		m_playerThread->Wait();
		m_playerThread->Delete();
	}
	else if (sm_playingVideo && ! sm_stopping)
	{
		g_formVideo->Hide();
		sm_videoPlayer->Hide();
		if ( ! sm_stopping)
		{
			sm_videoPlayer->Stop();
		}
	}
	m_mediaBar->SetValue( 0);
	m_status = STATUS_STOP;
	m_fileStatus = fsNone;
	m_playerThread = NULL;
	m_stopping = false;
//	std::cout << "FormMain :: Stop - End\n";
}

//**********************************************************************************************************

void FormMain :: NextFile()
{
//	std::cout << "FormMain :: NextFile - Begin\n";
	if (m_playerThread == NULL && ! sm_playingVideo)
	{
		Log::LogMessage( "FormMain :: NextFile - End - Player thread null");
		return;
	}
	Stop();
	_selectNext();
//	std::cout << "FormMain :: NextFile - End\n";
}

//**********************************************************************************************************

bool FormMain :: DeleteSelectedFile()
{
//	std::cout << "FormMain :: DeleteSelectedFile - Begin\n";
	if (g_formPlaylist->GetSelectedList() == wxT( "Audio"))
	{
		m_filesList.Remove( g_formPlaylist->GetSelectedFile());
//		std::cout << "FormMain :: DeleteSelectedFile - End\n";
		return true;
	}
	else if (sm_playingVideo)
	{  
		m_vidFilesList.Remove( g_formPlaylist->GetSelectedVidFile());
		sm_videoPlayer->Hide();
//		std::cout << "FormMain :: DeleteSelectedFile - End\n";
		return true;
	}
	else
	{
		m_cdFilesList.Remove( g_formPlaylist->GetSelectedCDFile());
		return true;
	}
	Log::LogMessage( "ERROR : FormMain :: DeleteSelectedFile - End - Can't delete it");
	return false;
}

//**********************************************************************************************************

void FormMain :: ExportPlayList( const wxString & p_destDir)
{
//	std::cout << "FormMain :: ExportPlayList - Begin\n";
	wxTextFile * l_file = new wxTextFile( p_destDir);
	if (l_file->Exists())
	{
		l_file->Open();
		l_file->Clear();
	}
	else
	{
		l_file->Create();
	}
	for (size_t i = 0 ; i < m_filesList.size() ; i++)
	{
		l_file->AddLine( m_filesList[i]);
	}
	for (size_t i = 0 ; i < m_vidFilesList.size() ; i++)
	{
		l_file->AddLine( m_vidFilesList[i]);
	}
	for (size_t i = 0 ; i < m_cdFilesList.size() ; i++)
	{
		l_file->AddLine( m_cdFilesList[i]);
	}
	l_file->Write();
	l_file->Close();
//	std::cout << "FormMain :: ExportPlayList - End\n";
}

//**********************************************************************************************************

void FormMain :: ImportPlayList (const wxString & p_srcDir)
{              
//	std::cout << "FormMain :: ExportPlayList - Begin\n";
	if (p_srcDir.IsEmpty())
	{          
		Log::LogMessage( "ERROR : FormMain :: NextFile - End - Void playlist file name");
		return;
	}
	wxTextFile * l_file = new wxTextFile( p_srcDir);
	if ( ! l_file->Exists())
	{
		Log::LogMessage( "ERROR : FormMain :: NextFile - End - Can't read playlist file");
		delete l_file;
		return;
	}
	l_file->Open();
	m_filesList.clear();
	m_vidFilesList.clear();
	m_cdFilesList.clear();
	wxString l_line = l_file->GetFirstLine();
	do
	{
		l_line = l_line.Trim();
		if (m_filesList.Index( l_line) == wxNOT_FOUND && m_vidFilesList.Index( l_line) == wxNOT_FOUND &&
			m_cdFilesList.Index( l_line) == wxNOT_FOUND)
		{
			_addFile( l_line);
		}
	}
	while ( ! (l_line = l_file->GetNextLine()).empty());
	l_file->Close();
//	std::cout << "FormMain :: ExportPlayList - End\n";
}

//**********************************************************************************************************

void FormMain :: Randomise()
{             
//	std::cout << "FormMain :: Randomise - Begin\n";
	if (m_filesList.size() > 0)
	{
    	g_formPlaylist->CleanFiles();
		wxArrayString l_filesList;
		wxString l_fileName;
		int randNumber;
		size_t l_length = (*m_playingFilesList).size();

		while (l_length > 0)
		{
			srand( time( NULL));
			randNumber = (int)(((double) rand() / ((double) RAND_MAX + 1)) * l_length);
			l_fileName = (*m_playingFilesList)[randNumber];
			(*m_playingFilesList).RemoveAt( randNumber);
			l_filesList.push_back( l_fileName);
			g_formPlaylist->AddFile( l_fileName);
			l_length = (*m_playingFilesList).size();
		}
		m_filesList.clear();
		m_filesList = wxArrayString( l_filesList);
		l_fileName = (*m_playingFilesList)[0];
//		g_formPlaylist->SetSelected( l_fileName);
//		SetFile( l_fileName, false, false);
	}
//	std::cout << "FormMain :: Randomise - End\n";
}

//**********************************************************************************************************

void FormMain :: ChangeVolume( int p_change)
{               
//	std::cout << "FormMain :: ChangeVolume - Begin\n";
	int l_volume = m_volumeControl->GetValue() + p_change;
	l_volume = min(max(l_volume, -100), 0);
	m_volumeControl->SetValue( l_volume);
//	std::cout << "FormMain :: ChangeVolume - End\n";
}

//**********************************************************************************************************

void FormMain :: SetMediaTime( unsigned int p_mediaTime)
{
	wxString l_str;
	unsigned int l_nbMin = p_mediaTime / 60000;
	unsigned int l_nbSec = (p_mediaTime % 60000) / 1000;
	l_str << l_nbMin << wxT( "min") << l_nbSec << wxT( "s");
	Log::LogMessage( "GetMediaTime : %d", static_cast <char *>( l_str.char_str()));
	m_totalTime->SetLabel( l_str);
}

//**********************************************************************************************************

void FormMain :: AddFile( const wxString & p_file)
{
	if (m_filesList.Index( p_file) == wxNOT_FOUND && m_vidFilesList.Index( p_file) == wxNOT_FOUND &&
		m_cdFilesList.Index( p_file) == wxNOT_FOUND)
	{
		_addFile( p_file);
	}
}

//**********************************************************************************************************

void FormMain :: _findFiles( const wxString & p_foldername)
{
	wxArrayString l_files;
	wxDir::GetAllFiles( p_foldername, & l_files);
	wxString l_previousFileName;
	for (size_t i = 0 ; i < l_files.size() ; i++)
	{
		if (IsMedia( l_files[i]))
		{
			if (l_previousFileName != l_files[i])
			{
				l_previousFileName = l_files[i];
				_addFile( l_files[i]);
			}
		}
	}
}

//**********************************************************************************************************

void FormMain :: _readCfgFile( const wxString & p_fileName)
{                            
//	std::cout << "FormMain :: ReadCfgFile - Begin\n";
	wxTextFile * l_file = new wxTextFile( p_fileName);
	if ( ! l_file->Exists())
	{
		return;
	}
	l_file->Open();
	wxString l_line = l_file->GetFirstLine();
	do
	{
//		std::cout << l_line << "\n";
		if (l_line == wxT( "[styles]"))
		{
			_readCfgStyles( l_file);
		}
	}
	while (l_file->GetCurrentLine() < l_file->GetLineCount() && ! (l_line = l_file->GetNextLine()).empty());
	l_file->Close();
//	std::cout << "FormMain :: ReadCfgFile - End\n";
}

//**********************************************************************************************************

void FormMain :: _readCfgStyles( wxTextFile * p_file)
{
//	std::cout << "FormMain :: ReadCfgStyles - Begin\n";
	for (DesignMap::iterator l_it = m_designs.begin() ; l_it != m_designs.end() ; ++l_it)
	{
		delete l_it->second;
	}
	m_designs.clear();
	wxString l_line;
	SimpleDesign * l_design = NULL;
	while (p_file->GetCurrentLine() < p_file->GetLineCount() && (l_line = p_file->GetNextLine()) != wxT( "[end]"))
	{
//		std::cout << l_line << "\n";
		l_line = l_line.Trim();
		if (l_line.Find( wxT( "name")) == 0)
		{
			if (l_design != NULL)
			{
				m_designs.insert( DesignMap::value_type( l_design->Name, l_design));
			}
			l_design = new SimpleDesign;
			l_line.Replace( wxT( "name "), wxT( ""));
			l_design->Name = l_line;
		}   
		else if (l_line.Find( wxT( "GeneralColor")) == 0)
		{
			l_line.Replace( wxT( "GeneralColor "), wxT( ""));
			l_design->m_1stColor = _getColour( l_line);
		}
		else if (l_line.Find( wxT( "GeneralTxtColor")) == 0)
		{
			l_line.Replace( wxT( "GeneralTxtColor "), wxT( ""));
			l_design->m_1stTxtColor = _getColour( l_line);
		} 
		else if (l_line.Find( wxT( "BtnEnabledColorTxt")) == 0)
		{
			l_line.Replace( wxT( "BtnEnabledColorTxt "), wxT( ""));
			l_design->m_btnFontColours[jiENABLE] = _getColour( l_line);
		}
		else if (l_line.Find( wxT( "BtnDisabledColorTxt")) == 0)
		{
			l_line.Replace( wxT( "BtnDisabledColorTxt "), wxT( ""));
			l_design->m_btnFontColours[jiDISABLE] = _getColour( l_line);
		}
		else if (l_line.Find( wxT( "BtnDownColorTxt")) == 0)
		{
			l_line.Replace( wxT( "BtnDownColorTxt "), wxT( ""));
			l_design->m_btnFontColours[jiDOWN] = _getColour( l_line);
		}
		else if (l_line.Find( wxT( "BtnMouseOverColorTxt")) == 0)
		{
			l_line.Replace( wxT( "BtnMouseOverColorTxt "), wxT( ""));
			l_design->m_btnFontColours[jiMOUSEOVER] = _getColour( l_line);
		}
		else if (l_line.Find( wxT( "BtnEnabledColor")) == 0)
		{
			l_line.Replace( wxT( "BtnEnabledColor "), wxT( ""));
			l_design->m_btnColours[jiENABLE] = _getColour( l_line);
		}
		else if (l_line.Find( wxT( "BtnDisabledColor")) == 0)
		{
			l_line.Replace( wxT( "BtnDisabledColor "), wxT( ""));
			l_design->m_btnColours[jiDISABLE] = _getColour( l_line);
		}
		else if (l_line.Find( wxT( "BtnDownColor")) == 0)
		{
			l_line.Replace( wxT( "BtnDownColor "), wxT( ""));
			l_design->m_btnColours[jiDOWN] = _getColour( l_line);
		}
		else if (l_line.Find( wxT( "BtnMouseOverColor")) == 0)
		{
			l_line.Replace( wxT( "BtnMouseOverColor "), wxT( ""));
			l_design->m_btnColours[jiMOUSEOVER] = _getColour( l_line);
		}
		else if (l_line.Find( wxT( "ListColor")) == 0)
		{
			l_line.Replace( wxT( "ListColor "), wxT( ""));
			l_design->m_3rdColor = _getColour( l_line);
		}
		else if (l_line.Find( wxT( "ListTxtColor")) == 0)
		{
			l_line.Replace( wxT( "ListTxtColor "), wxT( ""));
			l_design->m_3rdTxtColor = _getColour( l_line);
		}
		else if (l_line.Find( wxT( "selected")) == 0)
		{
			if (l_design != NULL)
			{
				m_designs.insert( DesignMap::value_type( l_design->Name, l_design));
			}
			l_line.Replace( wxT( "selected "), wxT( ""));
			wxString l_name = l_line;
			l_name = l_name.Trim();
			if (m_designs.find( l_name) != m_designs.end())
			{
				l_design = m_designs.find( l_name)->second;
				if (l_design != NULL)
				{
					SetSimpleDesign(l_design);
				}
			}
			l_design = NULL;
		}
	}
//	std::cout << l_line << "\n";      
	if (l_design != NULL)
	{
		m_designs.insert( DesignMap::value_type( l_design->Name, l_design));
	}
//	std::cout << "FormMain :: ReadCfgStyles - End\n";
}                                                                               

//**********************************************************************************************************

wxColour FormMain :: _getColour( const wxString & p_sColour)
{
//	std::cout << "GetColour : " << p_sColour << "\n";
	wxColour l_colour( p_sColour);
	return l_colour;
}

//**********************************************************************************************************

void FormMain :: _addFile( const wxString & p_name)
{                
	if (p_name.IsEmpty())
	{          
		Log::LogMessage( "ERROR : FormMain :: AddFile - Void file name");
		return;
	}
	if (IsMedia( p_name) && wxFileName::FileExists( p_name))
	{
		if (IsVideo( p_name))
		{
			m_vidFilesList.push_back( p_name);
		}
		else
		{
			m_filesList.push_back( p_name);
		}
		g_formPlaylist->AddFile( p_name);
	}
	else
	{
		m_cdFilesList.push_back( p_name);
		g_formPlaylist->AddFile( p_name);
	}
}

//**********************************************************************************************************

void FormMain :: _selectNext()
{
//	std::cout << "FormMain :: SelectNext - Begin\n";
	size_t l_filesListLength = m_playingFilesList->size();

	if (l_filesListLength > m_playedFiles.size())
	{
		int l_index;
		wxString l_fileName;
		if (m_random)
		{
			srand( time( NULL));
			int l_index;
			do
			{
				l_index = (int)(((double) rand() / ((double) RAND_MAX + 1))
											* l_filesListLength);
				l_fileName = (*m_playingFilesList)[l_index];
			}
			while (m_playedFiles.Index( l_fileName) != wxNOT_FOUND);

			g_formPlaylist->SetSelected( l_fileName);
//			std::cout << "FormMain :: SelectNext - Random, not last [" << l_fileName << "]\n";
		}
		else
		{
			l_index = m_playingFilesList->Index( m_mediaName) + 1;
			l_fileName = (*m_playingFilesList)[l_index];
			g_formPlaylist->NextFile();
//			std::cout << "FormMain :: SelectNext - Not random, not Last [" << l_fileName << "]\n";
		}
		SetFile( l_fileName, true, true);
	}
	else if (m_looped)
	{
		m_playedFiles.clear();
		wxString l_fileName = (*m_playingFilesList)[0];
		g_formPlaylist->SetSelected( l_fileName);
//		std::cout << "FormMain :: SelectNext - Not random, last, looped [" << l_fileName << "]\n";
		SetFile( l_fileName, true, true);
	}
	else
	{
//		std::cout << "FormMain :: SelectNext - Not random, last, not looped\n";
		m_playedFiles.clear();
		sm_videoPlayer->Hide();
		SetLabel( wxT( "Joker's Player"));
	} 
//	std::cout << "FormMain :: SelectNext - End\n";
}

//**********************************************************************************************************

void FormMain :: _onCBLoopedClick( wxCommandEvent & p_event)
{
//	std::cout <<  "FormMain :: CBLoopedClick\n";
	m_looped = m_CBLooped->IsChecked();
}

//**********************************************************************************************************

void FormMain :: _onCBRandomClick( wxCommandEvent & p_event)
{
//	std::cout <<  "FormMain :: CBLoopedClick\n";
	m_random = m_CBRandom->IsChecked();
}

//**********************************************************************************************************

void FormMain :: _onMediaBarChange( wxScrollEvent & p_event)
{
	if (m_playerThread != NULL && ! m_playerThread->IsUpdatingBar())
	{
		m_playerThread->SetPosition( (float)(m_mediaBar->GetValue()) / (m_mediaBar->GetMax() - m_mediaBar->GetMin()));
	}
}

//**********************************************************************************************************

void FormMain :: _onVolumeControlChange( wxScrollEvent & p_event)
{
	if (m_playerThread != NULL)
	{
		m_playerThread->SetAudio( m_volumeControl->GetValue(), 0);
	}
}

//**********************************************************************************************************

void FormMain :: _onFormKeyDown( wxKeyEvent & p_event)
{
	int Key = p_event.GetKeyCode();
	if (Key == WXK_RIGHT)
	{
		FastForward();
	}
	else if (Key == WXK_LEFT)
	{
		FastBack();
	}
	else if (Key == WXK_NEXT)
	{
		NextFile();
	}
	else if (Key == WXK_PRIOR)
	{
		PreviousFile();
	}
	else if (Key == WXK_SUBTRACT)
	{
		ChangeVolume( -5);
	}
	else if (Key == WXK_ADD)
	{
		ChangeVolume( 5);
	}
	else if (Key == WXK_DELETE)
	{
		DeleteSelectedFile();
	}
}

//**********************************************************************************************************

void FormMain :: _onBtnAddFileClick( wxCommandEvent & p_event)
{
	wxFileDialog * l_dialog = new wxFileDialog( this, wxT( "Choisissez un fichier"), wxEmptyString, 
														wxEmptyString, wxT( "All Media Files|*.mp3;*.wma;*.wav;*.avi;*.wmv;*.mkv|Audio Files (mp3, wma, wav)|*.mp3;*.wma; *.wav|Video Files (avi, wmv, mpg, mpeg, mp4, mkv)|*.avi; *.wmv;*.mpg;*.mpeg;*.mp4;*.mkv"), wxFD_MULTIPLE);
	if (l_dialog->ShowModal() == wxID_OK)
	{
		wxArrayString l_files;
		l_dialog->GetPaths( l_files);
		for (size_t j = 0 ; j < l_files.size() ; j++)
		{
			_addFile( l_files[j]);
		}
	}
}

//**********************************************************************************************************

void FormMain :: _onBtnAddFolderClick( wxCommandEvent & p_event)
{
	wxDirDialog * l_dialog = new wxDirDialog( this, wxT( "Choisissez un dossier"), m_folder, wxDD_DEFAULT_STYLE);
	if (l_dialog->ShowModal() == wxID_OK)
	{
		m_folder = l_dialog->GetPath();
		_findFiles( m_folder);
	}
}

//**********************************************************************************************************

void FormMain :: _onBtnEncodeClick( wxCommandEvent & p_event)
{
	g_formEncode->Show();
}

//**********************************************************************************************************

void FormMain :: _onMoveWindow( wxMoveEvent & p_event)
{
	if (g_formPlaylist != NULL)
	{
		wxPoint l_position = p_event.GetPosition();
		l_position.y += 163;
		l_position.x -= 3;
		g_formPlaylist->SetPosition( l_position);
	}
}

//**********************************************************************************************************

void FormMain :: _onClose( wxCloseEvent & p_event)
{
	Stop();
	m_trayIcon->RemoveIcon();
	wxGetApp().Exit();
	Destroy();
}

//**********************************************************************************************************

void FormMain :: _onBtnPreviousClick( wxCommandEvent & p_event)
{
	PreviousFile();
}

//**********************************************************************************************************

void FormMain :: _onBtnPlayClick( wxCommandEvent & p_event)
{
	if (m_status == STATUS_PAUSE)
	{
		Play();
	}
	else if (m_status != STATUS_PLAY)
	{
		SetFile( m_mediaName, true, true);
	}
}

//**********************************************************************************************************

void FormMain :: _onBtnPauseClick( wxCommandEvent & p_event)
{
	Pause();
}

//**********************************************************************************************************

void FormMain :: _onBtnStopClick( wxCommandEvent & p_event)
{
	Stop();
}

//**********************************************************************************************************

void FormMain :: _onBtnNextClick( wxCommandEvent & p_event)
{
	NextFile();
}

//**********************************************************************************************************

void FormMain :: _onIconize( wxIconizeEvent & p_event)
{
	Show( ! p_event.Iconized());
	if (p_event.Iconized())
	{
		SetWindowStyle( wxFRAME_NO_TASKBAR);
#ifdef WIN32
		m_trayIcon->SetIcon( wxIcon( Joker_xpm), wxT( "Joker's Player - ") + m_displayedMediaName);
#else
		m_trayIcon->SetIcon( wxIcon( Joker_xpm, wxBITMAP_TYPE_XPM), wxT( "Joker's Player - ") + m_displayedMediaName);
#endif
	}
	else
	{
		SetWindowStyle( wxMINIMIZE_BOX | wxSYSTEM_MENU | wxCAPTION | wxCLOSE_BOX);
		m_trayIcon->RemoveIcon();
		Restore();
	}
}

//**********************************************************************************************************

void FormMain :: _onMediaStop( wxMediaEvent & p_event)
{
	std::cout << "FormMain :: _onMediaStop\n";
	sm_videoPlayer->Seek( sm_videoPlayer->Length() << 1);
	sm_stopping = true;
	p_event.Veto();
}

//**********************************************************************************************************

void FormMain :: _onMediaLoaded( wxMediaEvent & p_event)
{
	std::cout << "FormMain :: _onMediaLoaded\n";
	if (sm_toPlay)
	{
		g_formVideo->SetDimensions( g_formVideo->GetSize());
		Play();
	}
}

//**********************************************************************************************************