//**********************************************************************************************************
#ifndef JPFormSearchH
#define JPFormSearchH
//**********************************************************************************************************
#include "../Common.h"
#include <wx/frame.h>
//**********************************************************************************************************
namespace JokersPlayer
{
	class FormSearch : public wxFrame
	{
	private:
		wxTextCtrl * m_editSearch;
		wxListBox * m_LBSearch;
#ifdef WIN32
		ImageButton * m_btnCancel;
#else
		wxButton * m_btnCancel;
#endif

	private:
		SimpleDesign * m_simpleDesign;
		wxArrayString m_filesList;
		wxArrayString m_displayedList;  
		int m_selectedItem;
		wxString m_currentFile;

	public:
		FormSearch( wxWindow * p_parent);
		void SetSimpleDesign( SimpleDesign * p_sd);
		void SetFilesList( wxArrayString p_list);

	private:
		wxArrayString Split( wxString p_txt, char p_separator);
		void UpdateListBox();

		void _onBtnCancelClick		( wxCommandEvent & p_event);
		void _onEditSearchChange	( wxCommandEvent & p_event);
		void _onLBSearchDblClick	( wxCommandEvent & p_event);
		void _onLBSearchSelect		( wxCommandEvent & p_event);

		DECLARE_EVENT_TABLE()
	};
}
//**********************************************************************************************************
#endif                                                                          
//**********************************************************************************************************
