//**********************************************************************************************************
#include "PrecompiledHeader.h"

#include "../Log.h"

#include "FormTagEdit.h"
#include "../special/ImageButton.h"
#include "../Log.h"
//**********************************************************************************************************
using namespace JokersPlayer;
//**********************************************************************************************************
FormTagEdit * g_formTagEdit;
//**********************************************************************************************************
enum FormTagEditIDs
{
	tageditOk,
	tageditCancel,
	tageditTitle,
	tageditNumber,
	tageditArtist,
	tageditGender,
	tageditYear,
	tageditAlbum
};
//**********************************************************************************************************
BEGIN_EVENT_TABLE( FormTagEdit, wxFrame)
	EVT_BUTTON(		tageditOk,		FormTagEdit::_onBtnValidateClick)
	EVT_BUTTON(		tageditCancel,	FormTagEdit::_onBtnCancelClick)
	EVT_TEXT_ENTER(	tageditYear,	FormTagEdit::_onEditYearChange)
	EVT_TEXT_ENTER(	tageditNumber,	FormTagEdit::_onEditTrackChange)
END_EVENT_TABLE()
//**********************************************************************************************************

FormTagEdit :: FormTagEdit( wxWindow * p_parent)
	:	wxFrame( p_parent, wxID_ANY, wxT( "Edition du Tag ID3"), wxPoint( 0, 0), wxSize( 430, 250), wxFRAME_TOOL_WINDOW | wxCAPTION | wxCLOSE_BOX | wxFRAME_FLOAT_ON_PARENT),
		m_simpleDesign( NULL)
{
#ifndef WIN32
	g_formTagEdit = this;

	wxSize l_size = GetClientSize();
	m_container = new wxPanel( this, wxID_ANY, wxPoint( 0, 0), l_size);

	m_file = new wxStaticText( m_container, wxID_ANY, wxEmptyString, wxPoint( 10, 10), wxSize( l_size.y - 20, 20));
	m_title = new wxStaticText( m_container, wxID_ANY, wxT( "Titre"), wxPoint( 10, 40), wxSize( 60, 20));
	m_album = new wxStaticText( m_container, wxID_ANY, wxT( "Album"), wxPoint( 10, 65), wxSize( 60, 20));
	m_artist = new wxStaticText( m_container, wxID_ANY, wxT( "Artiste"), wxPoint( 10, 90), wxSize( 60, 20));
	m_gender = new wxStaticText( m_container, wxID_ANY, wxT( "Genre"), wxPoint( 10, 115), wxSize( 60, 20));
	m_year = new wxStaticText( m_container, wxID_ANY, wxT( "Année"), wxPoint( 10, 140), wxSize( 60, 20));
	m_track = new wxStaticText( m_container, wxID_ANY, wxT( "N°"), wxPoint( 10, 165), wxSize( 60, 20));
	
	m_editTitle = new wxTextCtrl( m_container, tageditTitle, wxEmptyString, wxPoint( 70, 40), wxSize( 200, 20));
	m_editAlbum = new wxTextCtrl( m_container, tageditAlbum, wxEmptyString, wxPoint( 70, 65), wxSize( 200, 20));
	m_editArtist = new wxTextCtrl( m_container, tageditArtist, wxEmptyString, wxPoint( 70, 90), wxSize( 200, 20));
	m_editGender = new wxTextCtrl( m_container, tageditGender, wxEmptyString, wxPoint( 70, 115), wxSize( 100, 20));
	m_editYear = new wxTextCtrl( m_container, tageditYear, wxEmptyString, wxPoint( 70, 140), wxSize( 60, 20), wxTE_PROCESS_ENTER);
	m_editTrack = new wxTextCtrl( m_container, tageditNumber, wxEmptyString, wxPoint( 70, 165), wxSize( 30, 20), wxTE_PROCESS_ENTER);

	m_btnValidate = new wxButton( m_container, tageditOk, wxT( "Valider"), wxPoint( 10, l_size.y - 35), wxSize( 90, 32), g_buttonStyle);
	m_btnCancel = new wxButton( m_container, tageditCancel, wxT( "Annuler"), wxPoint( 110, l_size.y - 35), wxSize( 90, 32), g_buttonStyle);
#endif
}

//**********************************************************************************************************

void FormTagEdit :: SetSimpleDesign( SimpleDesign * p_sd)
{
#ifndef WIN32
	if (p_sd == NULL)
	{
		Log::LogMessage( "ERROR : FormTagEdit :: SetSimpleDesign - Design NulwxT( ");
		return;
	}

	m_simpleDesign = p_sd;

	SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_file->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_file->SetForegroundColour( m_simpleDesign->m_1stTxtColor);

	m_btnValidate->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_btnCancel->SetBackgroundColour( m_simpleDesign->m_1stColor);

	m_title->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_title->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_editTitle->SetBackgroundColour( m_simpleDesign->m_3rdColor);
	m_editTitle->SetForegroundColour( m_simpleDesign->m_3rdTxtColor);
	
	m_album->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_album->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_editAlbum->SetBackgroundColour( m_simpleDesign->m_3rdColor);
	m_editAlbum->SetForegroundColour( m_simpleDesign->m_3rdTxtColor);
	
	m_artist->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_artist->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_editArtist->SetBackgroundColour( m_simpleDesign->m_3rdColor);
	m_editArtist->SetForegroundColour( m_simpleDesign->m_3rdTxtColor);
	
	m_gender->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_gender->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_editGender->SetBackgroundColour( m_simpleDesign->m_3rdColor);
	m_editGender->SetForegroundColour( m_simpleDesign->m_3rdTxtColor);
	
	m_year->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_year->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_editYear->SetBackgroundColour( m_simpleDesign->m_3rdColor);
	m_editYear->SetForegroundColour( m_simpleDesign->m_3rdTxtColor);
	
	m_track->SetBackgroundColour( m_simpleDesign->m_1stColor);
	m_track->SetForegroundColour( m_simpleDesign->m_1stTxtColor);
	m_editTrack->SetBackgroundColour( m_simpleDesign->m_3rdColor);
	m_editTrack->SetForegroundColour( m_simpleDesign->m_3rdTxtColor);
	
	Refresh();
#endif
}

//**********************************************************************************************************

void FormTagEdit :: Init( const wxString & p_fileName)
{
#ifndef WIN32
	wxFileName l_file( p_fileName);
	if (l_file.GetExt().MakeLower() != wxT( "mp3"))
	{
		return;
	}
	try
	{
		m_filePath = p_fileName;
		Log::LogMessage( wxT( "*	") + p_fileName);

		int l_tmp;
		TagLib::FileRef l_file( p_fileName.c_str());
		TagLib::Tag * l_tag = l_file.tag();

		m_file->SetLabel( p_fileName);
		m_editTitle->SetValue( wxString( l_tag->title().toCString(), wxConvLibc));
		m_editAlbum->SetValue( wxString( l_tag->album().toCString(), wxConvLibc));
		m_editArtist->SetValue( wxString( l_tag->artist().toCString(), wxConvLibc));
		m_editGender->SetValue( wxString( l_tag->genre().toCString(), wxConvLibc));
		m_editTrack->Clear();
		*m_editTrack << (l_tmp = l_tag->track());
		m_editYear->Clear();
		*m_editYear << (l_tmp = l_tag->year());
		Show();
	}
	catch ( ... )
	{
		return;
	}
#endif
}

//**********************************************************************************************************

void FormTagEdit :: _onBtnCancelClick( wxCommandEvent & p_event)
{
#ifndef WIN32
	Hide();
#endif
}

//**********************************************************************************************************

void FormTagEdit :: _onBtnValidateClick( wxCommandEvent & p_event)
{
#ifndef WIN32
	try
	{
		TagLib::FileRef l_file( m_filePath.c_str());
		TagLib::Tag * l_tag = l_file.tag();
		l_tag->setTitle( m_editTitle->GetValue().c_str());
		l_tag->setAlbum( m_editAlbum->GetValue().c_str());
		l_tag->setArtist( m_editArtist->GetValue().c_str());
		l_tag->setGenre( m_editGender->GetValue().c_str());
		unsigned long l_year;
		m_editYear->GetValue().ToULong( & l_year);
		l_tag->setYear( l_year);
		unsigned long l_track;
		m_editTrack->GetValue().ToULong( & l_track);
		l_tag->setTrack( l_track);
		l_file.save();
	}
	catch ( ... )
	{
	}
	Hide();
#endif
}

//**********************************************************************************************************

void FormTagEdit :: _onEditYearChange( wxCommandEvent & p_event)
{
#ifndef WIN32
	if ( ! m_editYear->GetValue().IsNumber())
	{
		wxMessageBox( wxT( "Entrez un nombre entier"), wxT( "Erreur de saisie"));
	}
#endif
}

//**********************************************************************************************************

void FormTagEdit :: _onEditTrackChange( wxCommandEvent & p_event)
{
#ifndef WIN32
	if ( ! m_editTrack->GetValue().IsNumber())
	{
		wxMessageBox( wxT( "Entrez un nombre entier"), wxT( "Erreur de saisie"));
	}
#endif
}

//**********************************************************************************************************
