//**********************************************************************************************************
#ifndef ___JPFormTagEdit__
#define ___JPFormTagEdit__
//**********************************************************************************************************
#include <wx/frame.h>
#include "../Common.h"
//**********************************************************************************************************
namespace JokersPlayer
{
	class FormTagEdit : public wxFrame
	{
	private:
		wxPanel * m_container;
#ifdef WIN32
		ImageButton * m_btnValidate;
		ImageButton * m_btnCancel;
#else
		wxButton * m_btnValidate;
		wxButton * m_btnCancel;
#endif
		wxStaticText * m_title;
		wxStaticText * m_album;
		wxStaticText * m_artist;
		wxStaticText * m_gender;
		wxStaticText * m_year;
		wxStaticText * m_track;
		wxTextCtrl * m_editTitle;
		wxTextCtrl * m_editAlbum;
		wxTextCtrl * m_editArtist;
		wxTextCtrl * m_editGender;
		wxTextCtrl * m_editYear;
		wxTextCtrl * m_editTrack;
		wxStaticText * m_file;

		SimpleDesign * m_simpleDesign;
		wxString m_filePath;

	public:
		FormTagEdit( wxWindow * p_parent);
		void SetSimpleDesign( SimpleDesign * p_sd);
		void Init( const wxString & p_fileName);

	private:

		void _onBtnCancelClick		( wxCommandEvent & p_event);
		void _onBtnValidateClick	( wxCommandEvent & p_event);
		void _onEditYearChange		( wxCommandEvent & p_event);
		void _onEditTrackChange		( wxCommandEvent & p_event);

		DECLARE_EVENT_TABLE()
	};
}
//**********************************************************************************************************
#endif
//**********************************************************************************************************
