//**********************************************************************************************************
#ifndef ___FormVideo___
#define ___FormVideo___
//**********************************************************************************************************  
#include "../Common.h"
#include <wx/frame.h>
//**********************************************************************************************************
namespace JokersPlayer
{
	class FormVideo : public wxFrame
	{
	private:
		wxTimer * m_timerCursorOnFullScreen;
		wxTimer * m_timerControlOnFullScreen;
		ImageButton * m_btnPrevious;
		ImageButton * m_btnPlay;
		ImageButton * m_btnPause;
		ImageButton * m_btnStop;
		ImageButton * m_btnNext;

		SimpleDesign * m_simpleDesign;
		wxSize m_dimension;
		bool m_fullScreen;
		int m_width;
		int m_height;
		int m_top;
		int m_left;
		wxCursor m_cursor;

	public:
		wxSlider * m_mediaBar;
		wxPanel * m_fullScreenControls;

	public:		// Dclarations de l'utilisateur
		FormVideo( wxWindow * p_parent);

		void SetSimpleDesign( SimpleDesign * p_sd);
		void ToggleFullScreen( bool p_full);
		void RefreshScreen();
		void SetDimensions( const wxSize & p_dim);
		void StartTimer();

	private:
		void _onPaint							( wxPaintEvent & p_event);
		void _onFormClose						( wxCloseEvent & p_event);
		void _onFormResize						( wxSizeEvent & p_event);
		void _onFormKeyDown						( wxKeyEvent & p_event);
		void _onVideoPanelDblClick				( wxMouseEvent & p_event);
		void _onTimerCursorOnFullScreenTimer	( wxTimerEvent & p_event);
		void _onTimerControlOnFullScreenTimer	( wxTimerEvent & p_event);
		void _onFormMouseMove					( wxMouseEvent & p_event);
		void _onVideoPanelMouseMove				( wxMouseEvent & p_event);
		void _onBtnPreviousClick				( wxCommandEvent & p_event);
		void _onBtnPlayClick					( wxCommandEvent & p_event);
		void _onBtnPauseClick					( wxCommandEvent & p_event);
		void _onBtnStopClick					( wxCommandEvent & p_event);
		void _onBtnNextClick					( wxCommandEvent & p_event);
		void _onMediaBarChange					( wxScrollEvent & p_event);

	public:
		inline bool IsFullScreen 	() {return m_fullScreen;}

		DECLARE_EVENT_TABLE()
	};
}
//**********************************************************************************************************
#endif
//**********************************************************************************************************
