//**********************************************************************************************************
#ifndef ___AudioPlayerThread___
#define ___AudioPlayerThread___
//**********************************************************************************************************
#include "../Common.h"
#include "PlayerThread.h"
#include <fmod.hpp>
//**********************************************************************************************************
namespace JokersPlayer
{
	class AudioPlayerThread : public PlayerThread
	{
	private:
		FMOD::System * m_system;
		FMOD::Sound * m_sound;
		FMOD::Channel * m_channel;

		unsigned int m_mediaTime;
		float m_currentTime;
		float m_volume;

	protected:
		virtual void * Entry();

	public:
		AudioPlayerThread();
		virtual bool LoadMedia( const wxString & p_url);
		virtual void StartPlayback();
		virtual void PausePlayback();
		virtual void Cleanup();
		virtual void SetPosition( float p_position);
		virtual wxString GetMediaTime();
		virtual bool SetAudio(int volume, int balance);
		virtual void Mute( bool p_mute);
		virtual void FastForward();
		virtual void FastBack();

		virtual wxString GetPlayerThreadType() { return wxT( "AudioPlayerThread"); }

	private:
		bool _checkFMODError( FMOD_RESULT p_result, unsigned int p_line, const char * p_file);
		const wxString _outputTypeToStr( FMOD_OUTPUTTYPE p_outputType);
		void _stopPlayback();
	};
}
//**********************************************************************************************************
#endif
//**********************************************************************************************************
