//**********************************************************************************************************
#ifndef ___CDPlayerThread___
#define ___CDPlayerThread___
//**********************************************************************************************************
#include "../Common.h"
#include "PlayerThread.h"
#include <fmod.hpp>
//**********************************************************************************************************
namespace JokersPlayer
{
	class CDPlayerThread : public PlayerThread
	{
	private:
		FMOD::System * m_system;
		FMOD::Sound * m_sound;
		FMOD::Sound * m_track;
		FMOD::Channel * m_channel;

		wxString m_drive;

		int m_tracksNumber;
		int m_trackNumber;
		unsigned int m_mediaTime;
		float m_currentTime;
		float m_volume;

	protected:
		virtual void * Entry();

	public:
		CDPlayerThread();
		virtual bool LoadMedia( const wxString & p_url);
		virtual void StartPlayback();
		virtual void PausePlayback();
		virtual void Cleanup();
		virtual void SetPosition( float p_position);
		virtual wxString GetMediaTime();
		virtual bool SetAudio( int volume, int balance);
		virtual void Mute( bool p_mute);
		virtual void FastForward();
		virtual void FastBack();

		virtual wxString GetPlayerThreadType() { return wxT( "CDPlayerThread"); }

		inline void SetTrackNumber( int p_trackNumber) { m_trackNumber = p_trackNumber; }

	private:
		bool _checkFMODError( FMOD_RESULT p_result, unsigned int p_line, const char * p_file);
		const wxString _outputTypeToStr( FMOD_OUTPUTTYPE p_outputType);
		void _stopPlayback();
	};
}
//**********************************************************************************************************
#endif
//**********************************************************************************************************
