//**********************************************************************************************************
#include "PrecompiledHeader.h"

#include "JokersCtrl.h"
#include "../gui/FormMain.h"
#include "../gui/FormVideo.h"
//**********************************************************************************************************
using namespace JokersPlayer;
extern FormMain * g_formMain;
extern FormVideo * g_formVideo;
//**********************************************************************************************************
BEGIN_EVENT_TABLE( JokerCtrl, wxMediaCtrl)
	EVT_LEFT_DCLICK(					JokerCtrl::_onMouseDblClick)
	EVT_KEY_DOWN(						JokerCtrl::_onKeyDown)
	EVT_MOTION(							JokerCtrl::_onMouseMove)
END_EVENT_TABLE()
//**********************************************************************************************************

void JokerCtrl :: _onMouseDblClick( wxMouseEvent & p_event)
{
	g_formVideo->ToggleFullScreen( ! g_formVideo->IsFullScreen());
}

//**********************************************************************************************************
void JokerCtrl :: _onMouseMove( wxMouseEvent & p_event)
{
	if (g_formVideo->IsFullScreen())
	{
		g_formVideo->m_fullScreenControls->Show();
		SetCursor( * wxSTANDARD_CURSOR);
		g_formVideo->SetCursor( * wxSTANDARD_CURSOR);
		g_formVideo->m_fullScreenControls->SetCursor( * wxSTANDARD_CURSOR);
		g_formVideo->StartTimer();
	}
}

//**********************************************************************************************************
void JokerCtrl :: _onKeyDown( wxKeyEvent & p_event)
{
	int Key = p_event.GetKeyCode();
	if (Key == VK_RIGHT)
	{
		g_formMain->FastForward();
	}
	else if (Key == VK_LEFT)
	{
		g_formMain->FastBack();
	}
	else if (Key == VK_PRIOR)
	{
		g_formMain->NextFile();
	}
	else if (Key == VK_NEXT)
	{
		g_formMain->PreviousFile();
	}
	else if (Key == VK_SPACE)
	{
		if (g_formMain->m_status == STATUS_PLAY)
		{
			g_formMain->Pause();
		}
		else if (g_formMain->m_status == STATUS_PAUSE)
		{
			g_formMain->Play();
		}
	}
	else if (Key == VK_SUBTRACT)
	{
		g_formMain->ChangeVolume(-5);
	}
	else if (Key == VK_ADD)
	{
		g_formMain->ChangeVolume(5);
	}
	else if (Key == VK_RETURN)
	{
		g_formVideo->ToggleFullScreen( true);
	}
	else if (Key == VK_ESCAPE)
	{
		if (g_formVideo->IsFullScreen())
		{
			g_formVideo->ToggleFullScreen( false);
			g_formVideo->RefreshScreen ();
        }
	}
}

//**********************************************************************************************************