//**********************************************************************************************************
#ifndef ___PlayerThread___
#define ___PlayerThread___
//**********************************************************************************************************
#include "../Common.h"
#include <wx/thread.h>
//**********************************************************************************************************
namespace JokersPlayer
{
	class PlayerThread : public wxThread
	{
	protected:
		bool m_muted;
		int m_status;
		bool m_updatingBar;

	protected:
		virtual void * Entry() = 0;

	public:
		PlayerThread()
			:	wxThread(),
				m_muted( false),
				m_status( STATUS_NONE),
				m_updatingBar( false)
		{
		}
		virtual bool LoadMedia( const wxString & p_url) = 0;
		virtual void StartPlayback() = 0;
		virtual void PausePlayback() = 0;
		virtual void Cleanup() = 0;
		virtual void SetPosition( float p_position) = 0;
		virtual wxString GetMediaTime() = 0;
		virtual bool SetAudio(int volume, int balance) = 0;
		virtual void Mute( bool p_mute) = 0;
		virtual void FastForward() = 0;
		virtual void FastBack() = 0;
		
		virtual wxString GetPlayerThreadType() = 0;

	public:
		inline bool IsRunning		() { return m_status >= STATUS_READY; }
		inline bool IsPlaying		() { return m_status == STATUS_PLAY; }
		inline int	GetStatus		() { return m_status; }
		inline bool	IsUpdatingBar	() { return m_updatingBar; }
	};
}
//**********************************************************************************************************
#endif                                 
//**********************************************************************************************************
